"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _child_process = require("child_process");

function execDocker(cmd, cb) {
  var i = (0, _child_process.spawn)("docker", cmd, {
    stdio: "inherit",
    env: process.env,
    shell: true
  });
  i.on("close", cb);
}

var DockerMgmt = {
  processCommand: function processCommand(PM2, start_id, select_id, action, cb) {
    PM2.Client.executeRemote("getSystemData", {}, function (err, sys_infos) {
      if (sys_infos.containers && sys_infos.containers.length == 0) {
        return cb(new Error("Process ".concat(select_id, " not found")));
      }

      var container = sys_infos.containers[select_id - start_id - 1];

      if (action == "stopProcessId") {
        execDocker(["stop", container.id], cb);
      }

      if (action == "deleteProcessId") {
        execDocker(["rm", container.id], cb);
      }

      if (action == "restartProcessId") {
        execDocker(["restart", container.id], cb);
      }
    });
  }
};
var _default = DockerMgmt;
exports["default"] = _default;