"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _commander = _interopRequireDefault(require("commander"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _eachLimit = _interopRequireDefault(require("async/eachLimit"));

var _series = _interopRequireDefault(require("async/series"));

var _eachSeries = _interopRequireDefault(require("async/eachSeries"));

var _forEachLimit = _interopRequireDefault(require("async/forEachLimit"));

var _debug = _interopRequireDefault(require("debug"));

var _util = _interopRequireDefault(require("util"));

var _chalk = _interopRequireDefault(require("chalk"));

var _fclone = _interopRequireDefault(require("fclone"));

var _crypto = _interopRequireDefault(require("crypto"));

var _semver = _interopRequireDefault(require("semver"));

var _dayjs = _interopRequireDefault(require("dayjs"));

var _pm2tIoAgent = _interopRequireDefault(require("pm2t-io-agent"));

var _Docker = _interopRequireDefault(require("./ExtraMgmt/Docker"));

var _constants = _interopRequireDefault(require("../constants"));

var _Client = _interopRequireDefault(require("../Client"));

var _Common = _interopRequireDefault(require("../Common"));

var _Config = _interopRequireDefault(require("../tools/Config"));

var _Modularizer = _interopRequireDefault(require("./Modules/Modularizer"));

var _paths = _interopRequireDefault(require("../../paths"));

var _UX = _interopRequireDefault(require("./UX"));

var _package = _interopRequireDefault(require("../../package.json"));

var _flagExt = _interopRequireDefault(require("./Modules/flagExt"));

var _Configuration = _interopRequireDefault(require("../Configuration"));

var _sexec = _interopRequireDefault(require("../tools/sexec"));

var _json = _interopRequireDefault(require("../tools/json5"));

var fmt = _interopRequireWildcard(require("../tools/fmt"));

var _copydirSync = _interopRequireDefault(require("../tools/copydirSync"));

var _Log = _interopRequireDefault(require("./Log"));

var _Dashboard = _interopRequireDefault(require("./Dashboard"));

var _Monit = _interopRequireDefault(require("./Monit"));

var _Utility = _interopRequireDefault(require("../Utility"));

var _pm2tDeploy = _interopRequireDefault(require("../submodules/pm2t-deploy"));

var _child_process = _interopRequireWildcard(require("child_process"));

var _os = require("os");

var _which = _interopRequireDefault(require("../tools/which"));

var _forEach = _interopRequireDefault(require("async/forEach"));

var _open = _interopRequireDefault(require("../tools/open"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var printError = _Common["default"].printError;
var printOut = _Common["default"].printOut;
var EXEC_TIMEOUT = 60000; // Default: 1 min

var debug = (0, _debug["default"])("pm2:cli");

var IMMUTABLE_MSG = _chalk["default"].bold.blue("Use --update-env to update environment variables");

var conf = _constants["default"];
/**
 * From Extra - Start
 */

function basicMDHighlight(lines) {
  console.log("\n\n+-------------------------------------+");
  console.log(_chalk["default"].bold("README.md content:"));
  lines = lines.split("\n");
  var isInner = false;
  lines.forEach(function (l) {
    if (l.startsWith("#")) {
      console.log(_chalk["default"].bold.green(l));
    } else if (isInner || l.startsWith("```")) {
      if (isInner && l.startsWith("```")) {
        isInner = false;
      } else if (isInner == false) {
        isInner = true;
      }

      console.log(_chalk["default"].grey(l));
    } else if (l.startsWith("`")) {
      console.log(_chalk["default"].grey(l));
    } else {
      console.log(l);
    }
  });
  console.log("+-------------------------------------+");
}
/**
 * From Extra - End
 */

/**
 * From Deploy - Start
 */

/**
 * From Version - Start
 */

/**
 * From Version - End
 */


function deployHelper() {
  console.log("");
  console.log("-----> Helper: Deployment with PM2");
  console.log("");
  console.log("  Generate a sample ecosystem.config.js with the command");
  console.log("  $ pm2 ecosystem");
  console.log("  Then edit the file depending on your needs");
  console.log("");
  console.log("  Commands:");
  console.log("    setup                run remote setup commands");
  console.log("    update               update deploy to the latest release");
  console.log("    revert [n]           revert to [n]th last deployment or 1");
  console.log("    curr[ent]            output current release commit");
  console.log("    prev[ious]           output previous release commit");
  console.log("    exec|run <cmd>       execute the given <cmd>");
  console.log("    list                 list previous deploy commits");
  console.log("    [ref]                deploy to [ref], the \"ref\" setting, or latest tag");
  console.log("");
  console.log("");
  console.log("  Basic Examples:");
  console.log("");
  console.log("    First initialize remote production host:");
  console.log("    $ pm2 deploy ecosystem.config.js production setup");
  console.log("");
  console.log("    Then deploy new code:");
  console.log("    $ pm2 deploy ecosystem.config.js production");
  console.log("");
  console.log("    If I want to revert to the previous commit:");
  console.log("    $ pm2 deploy ecosystem.config.js production revert 1");
  console.log("");
  console.log("    Execute a command on remote server:");
  console.log("    $ pm2 deploy ecosystem.config.js production exec \"pm2 restart all\"");
  console.log("");
  console.log("    PM2 will look by default to the ecosystem.config.js file so you dont need to give the file name:");
  console.log("    $ pm2 deploy production");
  console.log("    Else you have to tell PM2 the name of your ecosystem file");
  console.log("");
  console.log("    More examples in https://github.com/Unitech/pm2");
  console.log("");
}
/**
 * From Deploy - End
 */

/**
 * From Module - Start
 */

/**
 * From Module - End
 */

/**
 * From Configuration - Start
 */


function interactiveConfigEdit(cb) {
  _UX["default"].helpers.openEditor(_constants["default"].PM2_MODULE_CONF_FILE, {}, function (err, data) {
    _Common["default"].printOut(_chalk["default"].bold("Module configuration (%s) edited."), _constants["default"].PM2_MODULE_CONF_FILE);

    _Common["default"].printOut(_chalk["default"].bold("To take changes into account, please restart module related."), _constants["default"].PM2_MODULE_CONF_FILE);

    if (err) {
      return cb(_Common["default"].retErr(err));
    }

    return cb(null, {
      success: true
    });
  });
}
/**
 * Configuration
 */


function displayConf(target_app, cb) {
  if (typeof target_app == "function") {
    cb = target_app;
    target_app = null;
  }

  _Configuration["default"].getAll(function (err, data) {
    _UX["default"].helpers.dispKeys(data, target_app);

    return cb();
  });
}
/**
 * From Configuration - End
 */

/**
 * From Version - Start
 */


var exec = function exec(cmd, callback) {
  var output = "";

  var c = _child_process["default"].exec(cmd, {
    env: process.env,
    maxBuffer: 3 * 1024 * 1024,
    timeout: EXEC_TIMEOUT
  }, function (err) {
    if (callback) {
      callback(err ? err.code : 0, output);
    }
  });

  c.stdout.on("data", function (data) {
    output += data;
  });
  c.stderr.on("data", function (data) {
    output += data;
  });
};
/**
 *
 * @method execCommands
 * @param {string} repo_path
 * @param {object} command_list
 * @return
 */


var execCommands = function execCommands(repo_path, command_list, cb) {
  var stdout = "";
  (0, _eachSeries["default"])(command_list, function (command, callback) {
    stdout += "\n" + command;
    exec("cd " + repo_path + ";" + command, function (code, output) {
      stdout += "\n" + output;

      if (code === 0) {
        callback();
      } else {
        callback("`" + command + "` failed");
      }
    });
  }, function (err) {
    if (err) {
      return cb(stdout + "\n" + err);
    }

    return cb(null, stdout);
  });
};
/**
 * Description Search process.json for post-update commands
 * @method getPostUpdateCmds
 * @param {string} repo_path
 * @param {string} proc_name
 * @return
 */


var getPostUpdateCmds = function getPostUpdateCmds(repo_path, proc_name, cb) {
  if (typeof repo_path !== "string") {
    return cb([]);
  }

  if (repo_path[repo_path.length - 1] !== "/") {
    repo_path += "/";
  }

  var searchForCommands = function searchForCommands(file, callback) {
    _fs["default"].exists(repo_path + file, function (exists) {
      if (exists) {
        var data = null;

        try {
          var conf_string = _fs["default"].readFileSync(repo_path + file);

          data = _Common["default"].parseConfig(conf_string, repo_path + file);
        } catch (e) {
          console.error(e.message || e);
        }

        if (data && data.apps) {
          (0, _eachSeries["default"])(data.apps, function (item, callb) {
            if (item.name && item.name === proc_name) {
              if (item.post_update && (0, _typeof2["default"])(item.post_update) === "object") {
                if (item.exec_timeout) {
                  EXEC_TIMEOUT = parseInt(item.exec_timeout);
                }

                return callb(item.post_update);
              } else {
                return callb();
              }
            } else {
              return callb();
            }
          }, function (_final) {
            return callback(_final);
          });
        } else {
          return callback();
        }
      } else {
        return callback();
      }
    });
  };

  (0, _eachSeries["default"])(["ecosystem.json", "process.json", "package.json"], searchForCommands, function (_final2) {
    return cb(_final2 ? _final2 : []);
  });
};
/**
 * From Version - Start
 */

/**
 * From Startup - Start
 */

/**
   * If command is launched without root right
   * Display helper
   */


function isNotRoot(startup_mode, platform, opts, cb) {
  _Common["default"].printOut("".concat(_constants["default"].PREFIX_MSG, "To ").concat(startup_mode, " the Startup Script, copy/paste the following command:"));

  if (opts.user) {
    console.log("sudo env PATH=$PATH:" + _path["default"].dirname(process.execPath) + " pm2 " + opts.args[1].name() + " " + platform + " -u " + opts.user + " --hp " + process.env.HOME);
    return cb(new Error("You have to run this with elevated rights"));
  }

  return (0, _sexec["default"])("whoami", {
    silent: true
  }, function (err, stdout, stderr) {
    console.log("sudo env PATH=$PATH:" + _path["default"].dirname(process.execPath) + " " + require.main.filename + " " + opts.args[1].name() + " " + platform + " -u " + stdout.trim() + " --hp " + process.env.HOME);
    return cb(new Error("You have to run this with elevated rights"));
  });
}
/**
   * Detect running init system
   */


function detectInitSystem() {
  var hash_map = {
    "systemctl": "systemd",
    "update-rc.d": "upstart",
    "chkconfig": "systemv",
    "rc-update": "openrc",
    "launchctl": "launchd",
    "sysrc": "rcd",
    "rcctl": "rcd-openbsd",
    "svcadm": "smf"
  };
  var init_systems = Object.keys(hash_map);
  var i;

  for (i = 0; i < init_systems.length; i++) {
    if ((0, _which["default"])(init_systems[i]) != null) {
      break;
    }
  }

  if (i >= init_systems.length) {
    // Common.printError(cst.PREFIX_MSG_ERR + "Init system not found");
    _Common["default"].printError(new Error(_constants["default"].PREFIX_MSG_ERR + "Init system not found").stack);

    return null;
  }

  _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Init System found: " + _chalk["default"].bold(hash_map[init_systems[i]]));

  return hash_map[init_systems[i]];
}
/**
 * From Startup - End
 */

/**
 * From Containerizer - Start
 */


function pspawn(cmd) {
  return new Promise(function (resolve, reject) {
    var p_cmd = cmd.split(" ");
    var install_instance = (0, _child_process.spawn)(p_cmd[0], p_cmd.splice(1, cmd.length), {
      stdio: "inherit",
      env: process.env,
      shell: true
    });
    install_instance.on("close", function (code) {
      if (code != 0) {
        console.log(_chalk["default"].bold.red("Command failed"));
        return reject(new Error("Bad cmd return"));
      }

      return resolve({});
    });
    install_instance.on("error", function (err) {
      return reject(err);
    });
  });
}

function checkDockerSetup() {
  return new Promise(function (resolve, reject) {
    exec("docker version -f '{{.Client.Version}}'", function (err, stdout, stderr) {
      if (err) {
        console.error(_chalk["default"].red.bold("[Docker access] Error while trying to use docker command"));

        if (err.message && err.message.indexOf("Cannot connect to the Docker") > -1) {
          console.log();
          console.log(_chalk["default"].blue.bold("[Solution] Setup Docker to be able to be used without sudo rights:"));
          console.log(_chalk["default"].bold("$ sudo groupadd docker"));
          console.log(_chalk["default"].bold("$ sudo usermod -aG docker $USER"));
          console.log(_chalk["default"].bold("Then LOGOUT and LOGIN your Linux session"));
          console.log("Read more: http://bit.ly/29JGdCE");
        }

        return reject(err);
      }

      return resolve({});
    });
  });
}
/**
 * Switch Dockerfile mode
 * check test/programmatic/containerizer.mocha.js
 */


function parseAndSwitch(file_content, main_file, opts) {
  var lines = file_content.split("\n");
  var mode = opts.mode;
  lines[0] = "FROM keymetrics/pm2:" + opts.node_version;

  for (var i = 0; i < lines.length; i++) {
    var line = lines[i];

    if (["## DISTRIBUTION MODE", "## DEVELOPMENT MODE"].indexOf(line) > -1 || i == lines.length - 1) {
      lines.splice(i, lines.length);
      lines[i] = "## " + mode.toUpperCase() + " MODE";
      lines[i + 1] = "ENV NODE_ENV=" + (mode == "distribution" ? "production" : mode);

      if (mode == "distribution") {
        lines[i + 2] = "COPY . /var/app";
        lines[i + 3] = "CMD [\"pm2-docker\", \"" + main_file + "\", \"--env\", \"production\"]";
      }

      if (mode == "development") {
        lines[i + 2] = "CMD [\"pm2-dev\", \"" + main_file + "\", \"--env\", \"development\"]";
      }

      break;
    }
  }

  lines = lines.join("\n");
  return lines;
}
/**
 * Replace ENV, COPY and CMD depending on the mode
 * @param {String} docker_filepath Dockerfile absolute path
 * @param {String} main_file       Main file to start in container
 * @param {String} mode            Mode to switch the Dockerfile
 */


function switchDockerFile(docker_filepath, main_file, opts) {
  return new Promise(function (resolve, reject) {
    var data = _fs["default"].readFileSync(docker_filepath, "utf8").toString();

    if (["distribution", "development"].indexOf(opts.mode) == -1) {
      return reject(new Error("Unknown mode"));
    }

    var lines = parseAndSwitch(data, main_file, opts);

    _fs["default"].writeFile(docker_filepath, lines, function (err) {
      if (err) {
        return reject(err);
      }

      resolve({
        Dockerfile_path: docker_filepath,
        Dockerfile: lines,
        CMD: ""
      });
    });
  });
}
/**
 * Generate sample Dockerfile (lib/templates/Dockerfiles)
 * @param {String} docker_filepath Dockerfile absolute path
 * @param {String} main_file       Main file to start in container
 * @param {String} mode            Mode to switch the Dockerfile
 */


function generateDockerfile(docker_filepath, main_file, opts) {
  return new Promise(function (resolve, reject) {
    var tpl_file = _path["default"].join(_constants["default"].TEMPLATE_FOLDER, _constants["default"].DOCKERFILE_NODEJS);

    var template = _fs["default"].readFileSync(tpl_file, {
      encoding: "utf8"
    });

    var CMD;
    template = parseAndSwitch(template, main_file, opts);

    _fs["default"].writeFile(docker_filepath, template, function (err) {
      if (err) {
        return reject(err);
      }

      resolve({
        Dockerfile_path: docker_filepath,
        Dockerfile: template,
        CMD: CMD
      });
    });
  });
}

function handleExit(CLI, opts, mode) {
  process.on("SIGINT", function () {
    CLI.disconnect();

    if (mode != "distribution") {
      return false;
    }

    exec("docker ps -lq", function (err, stdout, stderr) {
      if (err) {
        console.error(err);
      }

      require("vizion").analyze({
        folder: process.cwd()
      }, function recur_path(err, meta) {
        if (!err && meta.revision) {
          var commit_id = _util["default"].format("#%s(%s) %s", meta.branch, meta.revision.slice(0, 5), meta.comment);

          console.log(_chalk["default"].bold.magenta("$ docker commit -m \"%s\" %s %s"), commit_id, stdout.replace("\n", ""), opts.imageName);
        } else {
          console.log(_chalk["default"].bold.magenta("$ docker commit %s %s"), stdout.replace("\n", ""), opts.imageName);
        }

        console.log(_chalk["default"].bold.magenta("$ docker push %s"), opts.imageName);
      });
    });
  });
}
/**
 * From Containerizer - End
 */

/**
 * Main Function to be imported
 * can be aliased to PM2
 *
 * To use it when PM2 is installed as a module:
 *
 * var PM2 = require('pm2');
 *
 * var pm2 = PM2(<opts>);
 *
 *
 * @param {Object}  opts
 * @param {String}  [opts.cwd=<current>]         override pm2 cwd for starting scripts
 * @param {String}  [opts.pm2_home=[<paths.js>]] pm2 directory for log, pids, socket files
 * @param {Boolean} [opts.independent=false]     unique PM2 instance (random pm2_home)
 * @param {Boolean} [opts.daemon_mode=true]      should be called in the same process or not
 * @param {String}  [opts.public_key=null]       pm2 plus bucket public key
 * @param {String}  [opts.secret_key=null]       pm2 plus bucket secret key
 * @param {String}  [opts.machine_name=null]     pm2 plus instance name
 */


var API = function API(_opts) {
  var _this = this;

  (0, _classCallCheck2["default"])(this, API);
  (0, _defineProperty2["default"])(this, "daemon_mode", void 0);
  (0, _defineProperty2["default"])(this, "pm2_home", void 0);
  (0, _defineProperty2["default"])(this, "public_key", void 0);
  (0, _defineProperty2["default"])(this, "secret_key", void 0);
  (0, _defineProperty2["default"])(this, "machine_name", void 0);
  (0, _defineProperty2["default"])(this, "cwd", void 0);
  (0, _defineProperty2["default"])(this, "_conf", void 0);
  (0, _defineProperty2["default"])(this, "Client", void 0);
  (0, _defineProperty2["default"])(this, "pm2_configuration", void 0);
  (0, _defineProperty2["default"])(this, "gl_interact_infos", void 0);
  (0, _defineProperty2["default"])(this, "gl_is_km_linked", void 0);
  (0, _defineProperty2["default"])(this, "gl_retry", void 0);
  (0, _defineProperty2["default"])(this, "connected", void 0);
  (0, _defineProperty2["default"])(this, "start_timer", void 0);
  (0, _defineProperty2["default"])(this, "connect", function (noDaemon, cb) {
    _this.start_timer = new Date();

    if (typeof cb == "undefined") {
      cb = noDaemon;
      noDaemon = false;
    } else if (noDaemon === true) {
      // Backward compatibility with PM2 1.x
      _this.Client.daemon_mode = false;
      _this.daemon_mode = false;
    }

    _this.Client.start(function (err, meta) {
      if (err) {
        return cb(err);
      }

      if (meta.new_pm2_instance == false && _this.daemon_mode === true) {
        return cb(err, meta);
      } // If new pm2 instance has been popped
      // Lauch all modules


      _this.launchAll(_this, function (err_mod) {
        return cb(err, meta);
      });
    });
  });
  (0, _defineProperty2["default"])(this, "destroy", function (cb) {
    debug("Killing and deleting current deamon");

    _this.killDaemon(function () {
      var cmd = "rm -rf " + this.pm2_home;

      var test_path = _path["default"].join(this.pm2_home, "module_conf.json"); // const test_path_2 = path.join(this.pm2_home, "pm2.pid");


      if (this.pm2_home.indexOf(".pm2") > -1) {
        return cb(new Error("Destroy is not a allowed method on .pm2"));
      }

      _fs["default"].access(test_path, _fs["default"].constants.R_OK, function (err) {
        if (err) {
          return cb(err);
        }

        debug("Deleting temporary folder %s", this.pm2_home);
        (0, _sexec["default"])(cmd, cb);
      });
    });
  });
  (0, _defineProperty2["default"])(this, "disconnect", function (cb) {
    if (!cb) {
      cb = function cb() {// do nothing
      };
    }

    _this.Client.close(function (err, data) {
      // debug('The session lasted %ds', (new Date() - that.start_timer) / 1000);
      return cb(err, data);
    });
  });
  (0, _defineProperty2["default"])(this, "close", function (cb) {
    _this.disconnect(cb);
  });
  (0, _defineProperty2["default"])(this, "launchModules", function (cb) {
    _this.launchAll(_this, cb);
  });
  (0, _defineProperty2["default"])(this, "launchBus", function (cb) {
    _this.Client.launchBus(cb);
  });
  (0, _defineProperty2["default"])(this, "exitCli", function (code) {
    // Do nothing if PM2 called programmatically (also in speedlist)
    if (conf.PM2_PROGRAMMATIC && process.env.PM2_USAGE != "CLI") {
      return false;
    }

    _pm2tIoAgent["default"].disconnectRPC(function () {
      _this.Client.close(function () {
        code = code || 0; // Safe exits process after all streams are drained.
        // file descriptor flag.

        var fds = 0; // exits process when stdout (1) and sdterr(2) are both drained.

        function tryToExit() {
          if (fds & 1 && fds & 2) {
            // debug('This command took %ds to execute', (new Date() - that.start_timer) / 1000);
            process.exit(code);
          }
        }

        [process.stdout, process.stderr].forEach(function (std) {
          var fd = std.fd;

          if (!std.bufferSize) {
            // bufferSize equals 0 means current stream is drained.
            fds = fds | fd;
          } else {
            // Appends nothing to the std queue, but will trigger `tryToExit` event on `drain`.
            std.write && std.write("", function () {
              fds = fds | fd;
              tryToExit();
            });
          } // Does not write anything more.


          delete std.write;
        });
        tryToExit();
      });
    });
  });
  (0, _defineProperty2["default"])(this, "start", function (cmd, opts, cb) {
    if (typeof opts == "function") {
      cb = opts;
      opts = {};
    }

    if (!opts) {
      opts = {};
    }

    if (_semver["default"].lt(process.version, "6.0.0")) {
      _Common["default"].printOut(conf.PREFIX_MSG_WARNING + "Node 4 is deprecated, please upgrade to use pm2 to have all features");
    }

    if (_util["default"].isArray(opts.watch) && opts.watch.length === 0) {
      opts.watch = (opts.rawArgs ? !!~opts.rawArgs.indexOf("--watch") : !!~process.argv.indexOf("--watch")) || false;
    }

    if (_Common["default"].isConfigFile(cmd) || (0, _typeof2["default"])(cmd) === "object") {
      _this._startJson(cmd, opts, "restartProcessId", function (err, procs) {
        return cb ? cb(err, procs) : _this.speedList();
      });
    } else {
      _this._startScript(cmd, opts, function (err, procs) {
        return cb ? cb(err, procs) : _this.speedList(0);
      });
    }
  });
  (0, _defineProperty2["default"])(this, "reset", function (process_name, cb) {
    var processIds = function processIds(ids, cb) {
      (0, _eachLimit["default"])(ids, conf.CONCURRENT_ACTIONS, function (id, next) {
        _this.Client.executeRemote("resetMetaProcessId", id, function (err, res) {
          if (err) {
            console.error(err);
          }

          _Common["default"].printOut(conf.PREFIX_MSG + "Resetting meta for process id %d", id);

          return next();
        });
      }, function (err) {
        if (err) {
          return cb(_Common["default"].retErr(err));
        }

        return cb ? cb(null, {
          success: true
        }) : _this.speedList();
      });
    };

    if (process_name == "all") {
      _this.Client.getAllProcessId(function (err, ids) {
        if (err) {
          _Common["default"].printError(err);

          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
        }

        return processIds(ids, cb);
      });
    } else if (isNaN(process_name)) {
      _this.Client.getProcessIdByName(process_name, function (err, ids) {
        if (err) {
          _Common["default"].printError(err);

          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
        }

        if (ids.length === 0) {
          _Common["default"].printError("Unknown process name");

          return cb ? cb(new Error("Unknown process name")) : _this.exitCli(conf.ERROR_EXIT);
        }

        return processIds(ids, cb);
      });
    } else {
      processIds([process_name], cb);
    }
  });
  (0, _defineProperty2["default"])(this, "update", function (cb) {
    _Common["default"].printOut("Be sure to have the latest version by doing `npm install pm2t@latest -g` before doing this procedure."); // Dump PM2 processes


    _this.Client.executeRemote("notifyKillPM2", {}, function () {// do nothing
    });

    _this.getVersion(function (err, new_version) {
      // If not linked to PM2 plus, and update PM2 to latest, display motd.update
      if (!_this.gl_is_km_linked && !err && _package["default"].version != new_version) {
        var dt = _fs["default"].readFileSync(_path["default"].resolve(__dirname, "../..", _this._conf.PM2_UPDATE));

        console.log(dt.toString());
      }

      _this.dump(function (err) {
        debug("Dumping successfull", err);

        _this.killDaemon(function () {
          // debug('------------------ Everything killed', arguments as any);
          _this.Client.launchDaemon({
            interactor: false
          }, function (err, child) {
            _this.Client.launchRPC(function () {
              _this.resurrect(function () {
                _Common["default"].printOut(_chalk["default"].blue.bold(">>>>>>>>>> PM2 updated"));

                _this.launchAll(_this, function () {
                  _pm2tIoAgent["default"].launchAndInteract(_this._conf, {
                    pm2_version: _package["default"].version
                  }, function (err, data, interactor_proc) {});

                  setTimeout(function () {
                    return cb ? cb(null, {
                      success: true
                    }) : _this.speedList();
                  }, 250);
                });
              });
            });
          });
        });
      });
    });

    return false;
  });
  (0, _defineProperty2["default"])(this, "reload", function (process_name, opts, cb) {
    if (typeof opts == "function") {
      cb = opts;
      opts = {};
    }

    var delay = _Common["default"].lockReload();

    if (delay > 0 && opts.force != true) {
      // Common.printError(conf.PREFIX_MSG_ERR + "Reload already in progress, please try again in " + Math.floor((conf.RELOAD_LOCK_TIMEOUT - delay) / 1000) + " seconds or use --force");
      _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "Reload already in progress, please try again in " + Math.floor((conf.RELOAD_LOCK_TIMEOUT - delay) / 1000) + " seconds or use --force").stack);

      return cb ? cb(new Error("Reload in progress")) : _this.exitCli(conf.ERROR_EXIT);
    }

    if (_Common["default"].isConfigFile(process_name)) {
      _this._startJson(process_name, opts, "reloadProcessId", function (err, apps) {
        _Common["default"].unlockReload();

        if (err) {
          return cb ? cb(err) : _this.exitCli(conf.ERROR_EXIT);
        }

        return cb ? cb(null, apps) : _this.exitCli(conf.SUCCESS_EXIT);
      });
    } else {
      if (opts && opts.env) {
        var err = "Using --env [env] without passing the ecosystem.config.js does not work";

        _Common["default"].err(err);

        _Common["default"].unlockReload();

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
      }

      if (opts && !opts.updateEnv) {
        _Common["default"].printOut(IMMUTABLE_MSG);
      }

      _this._operate("reloadProcessId", process_name, opts, function (err, apps) {
        _Common["default"].unlockReload();

        if (err) {
          return cb ? cb(err) : this.exitCli(conf.ERROR_EXIT);
        }

        return cb ? cb(null, apps) : this.exitCli(conf.SUCCESS_EXIT);
      });
    }
  });
  (0, _defineProperty2["default"])(this, "restart", function (cmd, opts, cb) {
    if (typeof opts == "function") {
      cb = opts;
      opts = {};
    }

    if (typeof cmd === "number") {
      cmd = cmd.toString();
    }

    if (cmd == "-") {
      // Restart from PIPED JSON
      process.stdin.resume();
      process.stdin.setEncoding("utf8");
      process.stdin.on("data", function (param) {
        process.stdin.pause();

        _this.actionFromJson("restartProcessId", param, opts, "pipe", cb);
      });
    } else if (_Common["default"].isConfigFile(cmd) || (0, _typeof2["default"])(cmd) === "object") {
      _this._startJson(cmd, opts, "restartProcessId", cb);
    } else {
      if (opts && opts.env) {
        var err = "Using --env [env] without passing the ecosystem.config.js does not work";

        _Common["default"].err(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
      }

      if (opts && !opts.updateEnv) {
        _Common["default"].printOut(IMMUTABLE_MSG);
      }

      _this._operate("restartProcessId", cmd, opts, cb);
    }
  });
  (0, _defineProperty2["default"])(this, "delete", function (process_name, jsonVia, cb) {
    if (typeof jsonVia === "function") {
      cb = jsonVia;
      jsonVia = null;
    }

    if (typeof process_name === "number") {
      process_name = process_name.toString();
    }

    if (jsonVia == "pipe") {
      return _this.actionFromJson("deleteProcessId", process_name, _commander["default"], "pipe", function (err, procs) {
        return cb ? cb(err, procs) : _this.speedList();
      });
    }

    if (_Common["default"].isConfigFile(process_name)) {
      return _this.actionFromJson("deleteProcessId", process_name, _commander["default"], "file", function (err, procs) {
        return cb ? cb(err, procs) : _this.speedList();
      });
    } else {
      _this._operate("deleteProcessId", process_name, function (err, procs) {
        return cb ? cb(err, procs) : _this.speedList();
      });
    }
  });
  (0, _defineProperty2["default"])(this, "stop", function (process_name, cb) {
    if (typeof process_name === "number") {
      process_name = process_name.toString();
    }

    if (process_name == "-") {
      process.stdin.resume();
      process.stdin.setEncoding("utf8");
      process.stdin.on("data", function (param) {
        process.stdin.pause();

        _this.actionFromJson("stopProcessId", param, _commander["default"], "pipe", function (err, procs) {
          return cb ? cb(err, procs) : _this.speedList();
        });
      });
    } else if (_Common["default"].isConfigFile(process_name)) {
      _this.actionFromJson("stopProcessId", process_name, _commander["default"], "file", function (err, procs) {
        return cb ? cb(err, procs) : _this.speedList();
      });
    } else {
      _this._operate("stopProcessId", process_name, function (err, procs) {
        return cb ? cb(err, procs) : _this.speedList();
      });
    }
  });
  (0, _defineProperty2["default"])(this, "list", function (opts, cb) {
    if (typeof opts == "function") {
      cb = opts;
      opts = null;
    }

    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
      }

      if (opts && opts.rawArgs && opts.rawArgs.indexOf("--watch") > -1) {
        var show = function show() {
          console.log("Show");
          process.stdout.write("\x1b[2J");
          process.stdout.write("\x1b[0f");
          console.log("Last refresh: ", (0, _dayjs["default"])().format());

          _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
            _UX["default"].list(list, null);
          });
        };

        show();
        setInterval(show, 900);
        return false;
      }

      return cb ? cb(null, list) : _this.speedList(null);
    });
  });
  (0, _defineProperty2["default"])(this, "killDaemon", function (cb) {
    process.env.PM2_STATUS = "stopping";

    _this.Client.executeRemote("notifyKillPM2", {}, function () {// do nothing
    });

    _Common["default"].printOut(conf.PREFIX_MSG + "[v] Modules Stopped");

    _this._operate("deleteProcessId", "all", function (err, list) {
      _Common["default"].printOut(conf.PREFIX_MSG + "[v] All Applications Stopped");

      process.env.PM2_SILENT = "false";

      _this.killAgent(function (err, data) {
        if (!err) {
          _Common["default"].printOut(conf.PREFIX_MSG + "[v] Agent Stopped");
        }

        _this.Client.killDaemon(function (err, res) {
          if (err) {
            _Common["default"].printError(err);
          }

          _Common["default"].printOut(conf.PREFIX_MSG + "[v] PM2 Daemon Stopped");

          return cb ? cb(err, res) : _this.exitCli(conf.SUCCESS_EXIT);
        });
      });
    });
  });
  (0, _defineProperty2["default"])(this, "kill", function (cb) {
    _this.killDaemon(cb);
  });
  (0, _defineProperty2["default"])(this, "_startScript", function (script, opts, cb) {
    console.log("script", script);

    if (typeof opts == "function") {
      cb = opts;
      opts = {};
    }
    /**
     * Commander.js tricks
     */


    var app_conf = _Config["default"].filterOptions(opts);

    console.log("app_conf 1", app_conf);
    var appConf = {};

    if (typeof app_conf.name == "function") {
      delete app_conf.name;
    }

    delete app_conf.args; // Retrieve arguments via -- <args>

    var argsIndex;

    if (opts.rawArgs && (argsIndex = opts.rawArgs.indexOf("--")) >= 0) {
      app_conf.args = opts.rawArgs.slice(argsIndex + 1);
    } else if (opts.scriptArgs) {
      app_conf.args = opts.scriptArgs;
    }

    app_conf.script = script;

    if (!app_conf.namespace) {
      app_conf.namespace = "default";
    }

    console.log("app_conf 2", app_conf);

    if ((appConf = _Common["default"].verifyConfs(app_conf)) instanceof Error) {
      _Common["default"].err(appConf);

      return cb ? cb(_Common["default"].retErr(appConf)) : _this.exitCli(conf.ERROR_EXIT);
    }

    console.log("app_conf 3", app_conf);
    console.log("appConf", appConf);
    app_conf = appConf[0];

    if (opts.watchDelay) {
      if (typeof opts.watchDelay === "string" && opts.watchDelay.indexOf("ms") !== -1) {
        app_conf.watch_delay = parseInt(opts.watchDelay);
      } else {
        app_conf.watch_delay = parseFloat(opts.watchDelay) * 1000;
      }
    }

    var mas = [];

    if (typeof opts.ext != "undefined") {
      _flagExt["default"].make_available_extension(opts, mas); // for -e flag

    }

    mas.length > 0 ? app_conf.ignore_watch = mas : 0;
    /**
     * If -w option, write configuration to configuration.json file
     */

    if (app_conf.write) {
      var dst_path = _path["default"].join(process.env.PWD || process.cwd(), app_conf.name + "-pm2.json");

      _Common["default"].printOut(conf.PREFIX_MSG + "Writing configuration to", _chalk["default"].blue(dst_path)); // pretty JSON


      try {
        _fs["default"].writeFileSync(dst_path, JSON.stringify(app_conf, null, 2));
      } catch (e) {
        console.error(e.stack || e);
      }
    }
    /**
     * If start <app_name> start/restart application
     */


    var restartExistingProcessName = function restartExistingProcessName(cb) {
      if (!isNaN(script) || typeof script === "string" && script.indexOf("/") != -1 || typeof script === "string" && _path["default"].extname(script) !== "") {
        return cb(null);
      }

      _this.Client.getProcessIdByName(script, function (err, ids) {
        if (err && cb) {
          return cb(err);
        }

        if (ids.length > 0) {
          _this._operate("restartProcessId", script, opts, function (err, list) {
            if (err) {
              return cb(err);
            }

            _Common["default"].printOut(conf.PREFIX_MSG + "Process successfully started");

            return cb(true, list);
          });
        } else {
          return cb(null);
        }
      });
    };
    /**
     * If start <namespace> start/restart namespace
     */


    var restartExistingNameSpace = function restartExistingNameSpace(cb) {
      if (!isNaN(script) || typeof script === "string" && script.indexOf("/") != -1 || typeof script === "string" && _path["default"].extname(script) !== "") {
        return cb(null);
      }

      if (script !== "all") {
        _this.Client.getProcessIdsByNamespace(script, function (err, ids) {
          if (err && cb) {
            return cb(err);
          }

          if (ids.length > 0) {
            _this._operate("restartProcessId", script, opts, function (err, list) {
              if (err) {
                return cb(err);
              }

              _Common["default"].printOut(conf.PREFIX_MSG + "Process successfully started");

              return cb(true, list);
            });
          } else {
            return cb(null);
          }
        });
      } else {
        _this._operate("restartProcessId", "all", function (err, list) {
          if (err) {
            return cb(err);
          }

          _Common["default"].printOut(conf.PREFIX_MSG + "Process successfully started");

          return cb(true, list);
        });
      }
    };

    var restartExistingProcessId = function restartExistingProcessId(cb) {
      if (isNaN(script)) {
        return cb(null);
      }

      _this._operate("restartProcessId", script, opts, function (err, list) {
        if (err) {
          return cb(err);
        }

        _Common["default"].printOut(conf.PREFIX_MSG + "Process successfully started");

        return cb(true, list);
      });
    };
    /**
     * Restart a process with the same full path
     * Or start it
     */


    var restartExistingProcessPathOrStartNew = function restartExistingProcessPathOrStartNew(cb) {
      _this.Client.executeRemote("getMonitorData", {}, function (err, procs) {
        if (err) {
          return cb ? cb(new Error(err)) : _this.exitCli(conf.ERROR_EXIT);
        }

        var full_path = _path["default"].resolve(_this.cwd, script);

        var managed_script = null;
        procs.forEach(function (proc) {
          if (proc.pm2_env.pm_exec_path == full_path && proc.pm2_env.name == app_conf.name) {
            managed_script = proc;
          }
        });

        if (managed_script && (managed_script.pm2_env.status == conf.STOPPED_STATUS || managed_script.pm2_env.status == conf.STOPPING_STATUS || managed_script.pm2_env.status == conf.ERRORED_STATUS)) {
          // Restart process if stopped
          var app_name = managed_script.pm2_env.name;

          _this._operate("restartProcessId", app_name, opts, function (err, list) {
            if (err) {
              return cb ? cb(new Error(err)) : _this.exitCli(conf.ERROR_EXIT);
            }

            _Common["default"].printOut(conf.PREFIX_MSG + "Process successfully started");

            return cb(true, list);
          });

          return false;
        } else if (managed_script && !opts.force) {
          _Common["default"].err("Script already launched, add -f option to force re-execution");

          return cb(new Error("Script already launched"));
        }

        var resolved_paths = null;

        try {
          console.log("cwd", _this.cwd);
          console.log("pm2_home", _this.pm2_home);
          console.log("app_conf", app_conf);
          resolved_paths = _Common["default"].resolveAppAttributes({
            cwd: _this.cwd,
            pm2_home: _this.pm2_home
          }, app_conf);
        } catch (e) {
          // Common.err(e.message);
          _Common["default"].err(e);

          return cb(_Common["default"].retErr(e));
        }

        _Common["default"].printOut(conf.PREFIX_MSG + "Starting %s in %s (%d instance" + (resolved_paths.instances > 1 ? "s" : "") + ")", resolved_paths.pm_exec_path, resolved_paths.exec_mode, resolved_paths.instances);

        if (!resolved_paths.env) {
          resolved_paths.env = {};
        } // Set PM2 HOME in case of child process using PM2 API


        resolved_paths.env["PM2_HOME"] = _this.pm2_home;

        var additional_env = _Modularizer["default"].getAdditionalConf(resolved_paths.name);

        resolved_paths.env = Object.assign({}, resolved_paths.env, additional_env); // Is KM linked?

        resolved_paths.km_link = _this.gl_is_km_linked;

        _this.Client.executeRemote("prepare", resolved_paths, function (err, data) {
          if (err) {
            // Common.printError(conf.PREFIX_MSG_ERR + "Error while launching application", err.stack || err);
            _Common["default"].printError(conf.PREFIX_MSG_ERR + "Error while launching application", err.stack || err);

            return cb(_Common["default"].retErr(err));
          }

          _Common["default"].printOut(conf.PREFIX_MSG + "Done.");

          return cb(true, data);
        });

        return false;
      });
    };

    (0, _series["default"])([restartExistingProcessName, restartExistingNameSpace, restartExistingProcessId, restartExistingProcessPathOrStartNew], function (err, data) {
      if (err instanceof Error) {
        return cb ? cb(err) : _this.exitCli(conf.ERROR_EXIT);
      }

      var ret = {};
      data.forEach(function (_dt) {
        if (_dt !== undefined) {
          ret = _dt;
        }
      });
      return cb ? cb(null, ret) : _this.speedList();
    });
  });
  (0, _defineProperty2["default"])(this, "_startJson", function (file, opts, action, pipe, cb) {
    var config = {};
    var appConf = [];
    var staticConf = [];
    var deployConf = {};
    var apps_info = [];
    /**
     * Get File configuration
     */

    if (typeof cb === "undefined" && typeof pipe === "function") {
      cb = pipe;
    }

    if ((0, _typeof2["default"])(file) === "object") {
      config = file;
    } else if (pipe === "pipe") {
      config = _Common["default"].parseConfig(file, "pipe");
    } else {
      var data = null;

      var isAbsolute = _path["default"].isAbsolute(file);

      var file_path = isAbsolute ? file : _path["default"].join(_this.cwd, file);
      debug("Resolved filepath %s", file_path);

      try {
        data = _fs["default"].readFileSync(file_path);
      } catch (e) {
        // Common.printError(conf.PREFIX_MSG_ERR + "File " + file + " not found");
        _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "File " + file + " not found").stack);

        return cb ? cb(_Common["default"].retErr(e)) : _this.exitCli(conf.ERROR_EXIT);
      }

      try {
        config = _Common["default"].parseConfig(data, file);
      } catch (e) {
        // Common.printError(conf.PREFIX_MSG_ERR + "File " + file + " malformated");
        _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "File " + file + " malformated").stack);

        console.error(e);
        return cb ? cb(_Common["default"].retErr(e)) : _this.exitCli(conf.ERROR_EXIT);
      }
    }
    /**
     * Alias some optional fields
     */


    if (config.deploy) {
      deployConf = config.deploy;
    }

    if (config["static"]) {
      staticConf = config["static"];
    }

    if (config.apps) {
      appConf = config.apps;
    } else if (config.pm2) {
      appConf = config.pm2;
    } else {
      appConf = config;
    }

    if (!Array.isArray(appConf)) {
      appConf = [appConf];
    }

    var verConf = _Common["default"].verifyConfs(appConf);

    if (verConf instanceof Error) {
      return cb ? cb(verConf) : _this.exitCli(conf.ERROR_EXIT);
    }

    process.env.PM2_JSON_PROCESSING = "true"; // Get App list

    var apps_name = [];
    var proc_list = {}; // Add statics to apps

    staticConf.forEach(function (serve) {
      appConf.push({
        name: serve.name ? serve.name : "static-page-server-".concat(serve.port),
        script: _path["default"].resolve(__dirname, "API", "Serve.js"),
        env: {
          PM2_SERVE_PORT: serve.port,
          PM2_SERVE_HOST: serve.host,
          PM2_SERVE_PATH: serve.path,
          PM2_SERVE_SPA: serve.spa,
          PM2_SERVE_DIRECTORY: serve.directory,
          PM2_SERVE_BASIC_AUTH: serve.basic_auth !== undefined,
          PM2_SERVE_BASIC_AUTH_USERNAME: serve.basic_auth ? serve.basic_auth.username : null,
          PM2_SERVE_BASIC_AUTH_PASSWORD: serve.basic_auth ? serve.basic_auth.password : null,
          PM2_SERVE_MONITOR: serve.monitor
        }
      });
    }); // Here we pick only the field we want from the CLI when starting a JSON

    appConf.forEach(function (app) {
      if (!app.env) {
        app.env = {};
      }

      app.env.io = app.io; // --only <app>

      if (opts.only) {
        var apps = opts.only.split(/,| /);

        if (apps.indexOf(app.name) == -1) {
          return false;
        }
      } // Namespace


      if (!app.namespace) {
        if (opts.namespace) {
          app.namespace = opts.namespace;
        } else {
          app.namespace = "default";
        }
      } // --watch


      if (!app.watch && opts.watch && opts.watch === true) {
        app.watch = true;
      } // --ignore-watch


      if (!app.ignore_watch && opts.ignore_watch) {
        app.ignore_watch = opts.ignore_watch;
      }

      if (opts.install_url) {
        app.install_url = opts.install_url;
      } // --instances <nb>


      if (opts.instances && typeof opts.instances === "number") {
        app.instances = opts.instances;
      } // --uid <user>


      if (opts.uid) {
        app.uid = opts.uid;
      } // --gid <user>


      if (opts.gid) {
        app.gid = opts.gid;
      } // Specific


      if (app.append_env_to_name && opts.env) {
        app.name += "-" + opts.env;
      }

      if (opts.name_prefix && app.name.indexOf(opts.name_prefix) == -1) {
        app.name = "".concat(opts.name_prefix, ":").concat(app.name);
      }

      app.username = _Common["default"].getCurrentUsername();
      apps_name.push(app.name);
    });

    _this.Client.executeRemote("getMonitorData", {}, function (err, raw_proc_list) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
      }
      /**
       * Uniquify in memory process list
       */


      raw_proc_list.forEach(function (proc) {
        proc_list[proc.name] = proc;
      });
      /**
       * Auto detect application already started
       * and act on them depending on action
       */

      (0, _eachLimit["default"])(Object.keys(proc_list), conf.CONCURRENT_ACTIONS, function (proc_name, next) {
        // Skip app name (--only option)
        if (apps_name.indexOf(proc_name) == -1) {
          return next();
        }

        if (!(action == "reloadProcessId" || action == "softReloadProcessId" || action == "restartProcessId")) {
          throw new Error("Wrong action called");
        }

        var apps = appConf.filter(function (app) {
          return app.name == proc_name;
        });
        var envs = apps.map(function (app) {
          // Binds env_diff to env and returns it.
          return _Common["default"].mergeEnvironmentVariables(app, opts.env, deployConf);
        }); // Assigns own enumerable properties of all
        // Notice: if people use the same name in different apps,
        //         duplicated envs will be overrode by the last one

        var env = envs.reduce(function (e1, e2) {
          e1 = _objectSpread(_objectSpread({}, e1), e2);
          return e1;
        }); // When we are processing JSON, allow to keep the new env by default

        env.updateEnv = true; // Pass `env` option

        _this._operate(action, proc_name, env, function (err, ret) {
          if (err) {
            _Common["default"].printError(err);
          } // For return


          apps_info = apps_info.concat(ret);

          _this.Client.notifyGod(action, proc_name); // And Remove from array to spy


          apps_name.splice(apps_name.indexOf(proc_name), 1);
          return next();
        });
      }, function (err) {
        if (err) {
          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
        }

        if (apps_name.length > 0 && action != "start") {
          _Common["default"].printOut(conf.PREFIX_MSG_WARNING + "Applications %s not running, starting...", apps_name.join(", "));
        } // Start missing apps


        return startApps(apps_name, function (err, apps) {
          apps_info = apps_info.concat(apps);
          return cb ? cb(err, apps_info) : _this.speedList(err ? 1 : 0);
        });
      });
      return false;
    });

    var startApps = function startApps(app_name_to_start, cb) {
      var apps_to_start = [];
      var apps_started = [];
      var apps_errored = [];
      appConf.forEach(function (app, i) {
        if (app_name_to_start.indexOf(app.name) != -1) {
          apps_to_start.push(appConf[i]);
        }
      });
      (0, _eachLimit["default"])(apps_to_start, conf.CONCURRENT_ACTIONS, function (app, next) {
        if (opts.cwd) {
          app.cwd = opts.cwd;
        }

        if (opts.force_name) {
          app.name = opts.force_name;
        }

        if (opts.started_as_module) {
          app.pmx_module = true;
        }

        var resolved_paths = null; // hardcode script name to use `serve` feature inside a process file

        if (app.script === "serve") {
          app.script = _path["default"].resolve(__dirname, "API", "Serve.js");
        }

        try {
          resolved_paths = _Common["default"].resolveAppAttributes({
            cwd: _this.cwd,
            pm2_home: _this.pm2_home
          }, app);
        } catch (e) {
          apps_errored.push(e);

          _Common["default"].err("Error: ".concat(e.message));

          return next();
        }

        if (!resolved_paths.env) {
          resolved_paths.env = {};
        } // Set PM2 HOME in case of child process using PM2 API


        resolved_paths.env["PM2_HOME"] = _this.pm2_home;

        var additional_env = _Modularizer["default"].getAdditionalConf(resolved_paths.name);

        resolved_paths.env = _objectSpread(_objectSpread({}, resolved_paths.env || {}), additional_env || {});
        resolved_paths.env = _Common["default"].mergeEnvironmentVariables(resolved_paths, opts.env, deployConf);
        delete resolved_paths.env.current_conf; // Is KM linked?

        resolved_paths.km_link = _this.gl_is_km_linked;

        if (resolved_paths.wait_ready) {
          _Common["default"].warn("App ".concat(resolved_paths.name, " has option 'wait_ready' set, waiting for app to be ready..."));
        }

        _this.Client.executeRemote("prepare", resolved_paths, function (err, data) {
          if (err) {
            // Common.printError(conf.PREFIX_MSG_ERR + "Process failed to launch %s", err.message ? err.message : err);
            _Common["default"].printError(conf.PREFIX_MSG_ERR + "Process failed to launch %s", err.stack ? err.stack : err);

            return next();
          }

          if (data.length === 0) {
            // Common.printError(conf.PREFIX_MSG_ERR + "Process config loading failed", data);
            _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "Process config loading failed").stack);

            return next();
          }

          _Common["default"].printOut(conf.PREFIX_MSG + "App [%s] launched (%d instances)", data[0].pm2_env.name, data.length);

          apps_started = apps_started.concat(data);
          next();
        });
      }, function (err) {
        var final_error = err || apps_errored.length > 0 ? apps_errored : null;
        return cb ? cb(final_error, apps_started) : _this.speedList();
      });
      return false;
    };
  });
  (0, _defineProperty2["default"])(this, "actionFromJson", function (action, file, opts, jsonVia, cb) {
    var appConf = {};
    var ret_processes = []; //accept programmatic calls

    if ((0, _typeof2["default"])(file) == "object") {
      cb = typeof jsonVia == "function" ? jsonVia : cb;
      appConf = file;
    } else if (jsonVia == "file") {
      var data = null;

      try {
        data = _fs["default"].readFileSync(file);
      } catch (e) {
        // Common.printError(conf.PREFIX_MSG_ERR + "File " + file + " not found");
        _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "File " + file + " not found").stack);

        return cb ? cb(_Common["default"].retErr(e)) : _this.exitCli(conf.ERROR_EXIT);
      }

      try {
        appConf = _Common["default"].parseConfig(data, file);
      } catch (e) {
        // Common.printError(conf.PREFIX_MSG_ERR + "File " + file + " malformated");
        _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "File " + file + " malformated").stack);

        console.error(e);
        return cb ? cb(_Common["default"].retErr(e)) : _this.exitCli(conf.ERROR_EXIT);
      }
    } else if (jsonVia == "pipe") {
      appConf = _Common["default"].parseConfig(file, "pipe");
    } else {
      _Common["default"].printError("Bad call to actionFromJson, jsonVia should be one of file, pipe");

      return _this.exitCli(conf.ERROR_EXIT);
    } // Backward compatibility


    if (appConf.apps) {
      appConf = appConf.apps;
    }

    if (!Array.isArray(appConf)) {
      appConf = [appConf];
    }

    if ((appConf = _Common["default"].verifyConfs(appConf)) instanceof Error) {
      return cb ? cb(appConf) : _this.exitCli(conf.ERROR_EXIT);
    }

    (0, _eachLimit["default"])(appConf, conf.CONCURRENT_ACTIONS, function (proc, next1) {
      var name = "";
      var new_env;

      if (!proc.name) {
        name = _path["default"].basename(proc.script);
      } else {
        name = proc.name;
      }

      if (opts.only && opts.only != name) {
        return process.nextTick(next1);
      }

      if (opts && opts.env) {
        new_env = _Common["default"].mergeEnvironmentVariables(proc, opts.env);
      } else {
        new_env = _Common["default"].mergeEnvironmentVariables(proc);
      }

      _this.Client.getProcessIdByName(name, function (err, ids) {
        if (err) {
          _Common["default"].printError(err);

          return next1();
        }

        if (!ids) {
          return next1();
        }

        (0, _eachLimit["default"])(ids, conf.CONCURRENT_ACTIONS, function (id, next2) {
          var opts = {}; //stopProcessId could accept options to?

          if (action == "restartProcessId") {
            opts = {
              id: id,
              env: new_env
            };
          } else {
            opts = id;
          }

          _this.Client.executeRemote(action, opts, function (err, res) {
            ret_processes.push(res);

            if (err) {
              _Common["default"].printError(err);

              return next2();
            }

            if (action == "restartProcessId") {
              _this.Client.notifyGod("restart", id);
            } else if (action == "deleteProcessId") {
              _this.Client.notifyGod("delete", id);
            } else if (action == "stopProcessId") {
              _this.Client.notifyGod("stop", id);
            }

            _Common["default"].printOut(conf.PREFIX_MSG + "[%s](%d) \u2713", name, id);

            return next2();
          });
        }, function (err) {
          return next1(null, ret_processes);
        });
      });
    }, function (err) {
      if (cb) {
        return cb(null, ret_processes);
      } else {
        return _this.speedList();
      }
    });
  });
  (0, _defineProperty2["default"])(this, "_operate", function (action_name, process_name, envs, cb) {
    var update_env = false;
    var ret = []; // Make sure all options exist

    if (!envs) {
      envs = {};
    }

    if (typeof envs == "function") {
      cb = envs;
      envs = {};
    } // Set via env.update (JSON processing)


    if (envs.updateEnv === true) {
      update_env = true;
    }

    var concurrent_actions = envs.parallel || conf.CONCURRENT_ACTIONS;

    if (!process.env.PM2_JSON_PROCESSING || envs.commands) {
      envs = _this._handleAttributeUpdate(envs);
    }
    /**
     * Set current updated configuration if not passed
     */


    if (!envs.current_conf) {
      var _conf = (0, _fclone["default"])(envs);

      envs = {
        current_conf: _conf
      }; // Is KM linked?

      envs.current_conf.km_link = _this.gl_is_km_linked;
    }
    /**
     * Operate action on specific process id
     */


    var processIds = function processIds(ids, cb) {
      _Common["default"].printOut(conf.PREFIX_MSG + "Applying action %s on app [%s](ids: %s)", action_name, process_name, ids);

      if (ids.length <= 2) {
        concurrent_actions = 1;
      }

      if (action_name == "deleteProcessId") {
        concurrent_actions = 10;
      }

      (0, _eachLimit["default"])(ids, concurrent_actions, function (id, next) {
        var opts; // These functions need extra param to be passed

        if (action_name == "restartProcessId" || action_name == "reloadProcessId" || action_name == "softReloadProcessId") {
          var new_env = {};

          if (update_env === true) {
            if (conf.PM2_PROGRAMMATIC == true) {
              new_env = _Common["default"].safeExtend({}, process.env);
            } else {
              new_env = Object.assign({}, process.env);
            }

            Object.keys(envs).forEach(function (k) {
              new_env[k] = envs[k];
            });
          } else {
            new_env = envs;
          }

          opts = {
            id: id,
            env: new_env
          };
        } else {
          opts = id;
        }

        _this.Client.executeRemote(action_name, opts, function (err, res) {
          if (err) {
            // Common.printError(conf.PREFIX_MSG_ERR + "Process %s not found", id);
            _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "Process %s not found" + id).stack);

            return next("Process ".concat(id, " not found"));
          }

          if (action_name == "restartProcessId") {
            _this.Client.notifyGod("restart", id);
          } else if (action_name == "deleteProcessId") {
            _this.Client.notifyGod("delete", id);
          } else if (action_name == "stopProcessId") {
            _this.Client.notifyGod("stop", id);
          } else if (action_name == "reloadProcessId") {
            _this.Client.notifyGod("reload", id);
          } else if (action_name == "softReloadProcessId") {
            _this.Client.notifyGod("graceful reload", id);
          }

          if (!Array.isArray(res)) {
            res = [res];
          } // Filter return


          res.forEach(function (proc) {
            _Common["default"].printOut(conf.PREFIX_MSG + "[%s](%d) \u2713", proc.pm2_env ? proc.pm2_env.name : process_name, id);

            if (action_name == "stopProcessId" && proc.pm2_env && proc.pm2_env.cron_restart) {
              _Common["default"].warn("App ".concat(_chalk["default"].bold(proc.pm2_env.name), " stopped but CRON RESTART is still UP ").concat(proc.pm2_env.cron_restart));
            }

            if (!proc.pm2_env) {
              return false;
            }

            ret.push({
              name: proc.pm2_env.name,
              namespace: proc.pm2_env.namespace,
              pm_id: proc.pm2_env.pm_id,
              status: proc.pm2_env.status,
              restart_time: proc.pm2_env.restart_time,
              pm2_env: {
                name: proc.pm2_env.name,
                namespace: proc.pm2_env.namespace,
                pm_id: proc.pm2_env.pm_id,
                status: proc.pm2_env.status,
                restart_time: proc.pm2_env.restart_time,
                env: proc.pm2_env.env
              }
            });
          });
          return next();
        });
      }, function (err) {
        if (err) {
          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
        }

        return cb ? cb(null, ret) : _this.speedList();
      });
    };

    if (process_name == "all") {
      // When using shortcuts like 'all', do not delete modules
      if (process.env.PM2_STATUS == "stopping") {
        _this.Client.getAllProcessId(function (err, ids) {
          reoperate(err, ids);
        });
      } else {
        _this.Client.getAllProcessIdWithoutModules(function (err, ids) {
          reoperate(err, ids);
        });
      }

      var reoperate = function reoperate(err, ids) {
        if (err) {
          _Common["default"].printError(err);

          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
        }

        if (!ids || ids.length === 0) {
          _Common["default"].printError(conf.PREFIX_MSG_WARNING + "No process found");

          return cb ? cb(new Error("process name not found")) : _this.exitCli(conf.ERROR_EXIT);
        }

        return processIds(ids, cb);
      };
    } else if (isNaN(process_name) && process_name[0] === "/" && process_name[process_name.length - 1] === "/") {
      var regex = new RegExp(process_name.replace(/\//g, ""));

      _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
        if (err) {
          _Common["default"].printError("Error retrieving process list: " + err);

          return cb(err);
        }

        var found_proc = [];
        list.forEach(function (proc) {
          if (regex.test(proc.pm2_env.name)) {
            found_proc.push(proc.pm_id);
          }
        });

        if (found_proc.length === 0) {
          _Common["default"].printError(conf.PREFIX_MSG_WARNING + "No process found");

          return cb ? cb(new Error("process name not found")) : _this.exitCli(conf.ERROR_EXIT);
        }

        return processIds(found_proc, cb);
      });
    } else if (isNaN(process_name)) {
      /**
       * We can not stop or delete a module but we can restart it
       * to refresh configuration variable
       */
      var allow_module_restart = action_name == "restartProcessId" ? true : false;

      _this.Client.getProcessIdByName(process_name, allow_module_restart, function (err, ids) {
        if (err) {
          _Common["default"].printError(err);

          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
        }

        if (ids && ids.length > 0) {
          /**
           * Determine if the process to restart is a module
           * if yes load configuration variables and merge with the current environment
           */
          var additional_env = _Modularizer["default"].getAdditionalConf(process_name);

          envs = _objectSpread(_objectSpread({}, envs), additional_env);
          return processIds(ids, cb);
        }

        _this.Client.getProcessIdsByNamespace(process_name, allow_module_restart, function (err, ns_process_ids) {
          if (err) {
            _Common["default"].printError(err);

            return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
          }

          if (!ns_process_ids || ns_process_ids.length === 0) {
            // Common.printError(conf.PREFIX_MSG_ERR + "Process or Namespace %s not found", process_name);
            _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "Process or Namespace %s not found" + process_name).stack);

            return cb ? cb(new Error("process or namespace not found")) : _this.exitCli(conf.ERROR_EXIT);
          }
          /**
           * Determine if the process to restart is a module
           * if yes load configuration variables and merge with the current environment
           */


          var ns_additional_env = _Modularizer["default"].getAdditionalConf(process_name);

          envs = _objectSpread(_objectSpread({}, envs), ns_additional_env);
          return processIds(ns_process_ids, cb);
        });
      });
    } else {
      if (_this.pm2_configuration.docker == "true" || _this.pm2_configuration.docker == true) {
        // Docker/Systemd process interaction detection
        _this.Client.executeRemote("getMonitorData", {}, function (err, proc_list) {
          var higher_id = 0;
          proc_list.forEach(function (p) {
            p.pm_id > higher_id ? higher_id = p.pm_id : null;
          }); // Is Docker/Systemd

          if (process_name > higher_id) {
            return _Docker["default"].processCommand(_this, higher_id, process_name, action_name, function (err) {
              if (err) {
                // Common.printError(conf.PREFIX_MSG_ERR + (err.message ? err.message : err));
                _Common["default"].printError(conf.PREFIX_MSG_ERR + (err.stack ? err.stack : err));

                return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
              }

              return cb ? cb(null, ret) : _this.speedList();
            });
          } // Check if application name as number is an app name


          _this.Client.getProcessIdByName(process_name, function (err, ids) {
            if (ids.length > 0) {
              return processIds(ids, cb);
            } // Check if application name as number is an namespace


            _this.Client.getProcessIdsByNamespace(process_name, function (err, ns_process_ids) {
              if (ns_process_ids.length > 0) {
                return processIds(ns_process_ids, cb);
              } // Else operate on pm id


              return processIds([process_name], cb);
            });
          });
        });
      } else {
        // Check if application name as number is an app name
        _this.Client.getProcessIdByName(process_name, function (err, ids) {
          if (ids.length > 0) {
            return processIds(ids, cb);
          } // Check if application name as number is an namespace


          _this.Client.getProcessIdsByNamespace(process_name, function (err, ns_process_ids) {
            if (ns_process_ids.length > 0) {
              return processIds(ns_process_ids, cb);
            } // Else operate on pm id


            return processIds([process_name], cb);
          });
        });
      }
    }
  });
  (0, _defineProperty2["default"])(this, "_handleAttributeUpdate", function (opts) {
    var conf = _Config["default"].filterOptions(opts);

    if (typeof conf.name != "string") {
      delete conf.name;
    }

    var argsIndex = 0;

    if (opts.rawArgs && (argsIndex = opts.rawArgs.indexOf("--")) >= 0) {
      conf.args = opts.rawArgs.slice(argsIndex + 1);
    }

    var appConf = _Common["default"].verifyConfs(conf)[0];

    if (appConf instanceof Error) {
      _Common["default"].printError("Error while transforming CamelCase args to underscore");

      return appConf;
    }

    if (argsIndex == -1) {
      delete appConf.args;
    }

    if (appConf.name == "undefined") {
      delete appConf.name;
    }

    delete appConf.exec_mode;

    if (_util["default"].isArray(appConf.watch) && appConf.watch.length === 0) {
      if (!~opts.rawArgs.indexOf("--watch")) {
        delete appConf.watch;
      }
    } // Options set via environment variables


    if (process.env.PM2_DEEP_MONITORING) {
      appConf.deep_monitoring = true;
    } // Force deletion of defaults values set by commander
    // to avoid overriding specified configuration by user


    if (appConf.treekill === true) {
      delete appConf.treekill;
    }

    if (appConf.pmx === true) {
      delete appConf.pmx;
    }

    if (appConf.vizion === true) {
      delete appConf.vizion;
    }

    if (appConf.automation === true) {
      delete appConf.automation;
    }

    if (appConf.autorestart === true) {
      delete appConf.autorestart;
    }

    return appConf;
  });
  (0, _defineProperty2["default"])(this, "getProcessIdByName", function (name, cb) {
    _this.Client.getProcessIdByName(name, function (err, id) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
      }

      console.log(id);
      return cb ? cb(null, id) : _this.exitCli(conf.SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "jlist", function (debug) {
    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        _Common["default"].printError(err);

        return _this.exitCli(conf.ERROR_EXIT);
      }

      if (debug) {
        process.stdout.write(_util["default"].inspect(list, false, null, false));
      } else {
        process.stdout.write(JSON.stringify(list));
      }

      _this.exitCli(conf.SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "slist", function (tree) {
    _this.Client.executeRemote("getSystemData", {}, function (err, sys_infos) {
      if (err) {
        _Common["default"].err(err);

        return _this.exitCli(conf.ERROR_EXIT);
      }

      if (tree === true) {// console.log(treeify.asTree(sys_infos, true))
      } else {
        process.stdout.write(_util["default"].inspect(sys_infos, false, null, false));
      }

      _this.exitCli(conf.SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "speedList", function (code, apps_acted) {
    // const systemdata = null;
    var acted = [];

    if (code != 0 && code != null) {
      return _this.exitCli(code ? code : conf.SUCCESS_EXIT);
    }

    if (apps_acted && apps_acted.length > 0) {
      apps_acted.forEach(function (proc) {
        acted.push(proc.pm2_env ? proc.pm2_env.pm_id : proc.pm_id);
      });
    }

    var doList = function doList(err, list, sys_infos) {
      if (err) {
        if (_this.gl_retry == 0) {
          _this.gl_retry += 1;
          return setTimeout(_this.speedList.bind(_this), 1400);
        }

        console.error("Error retrieving process list: %s.\nA process seems to be on infinite loop, retry in 5 seconds", err);
        return _this.exitCli(conf.ERROR_EXIT);
      }

      if (process.stdout.isTTY === false) {
        _UX["default"].list_min(list);
      } else if (_commander["default"].miniList && !_commander["default"].silent) {
        _UX["default"].list_min(list);
      } else if (!_commander["default"].silent) {
        if (_this.gl_interact_infos) {
          var dashboard_url = "https://app.pm2.io/#/r/".concat(_this.gl_interact_infos.public_key);

          if (_this.gl_interact_infos.info_node != "https://root.keymetrics.io") {
            dashboard_url = "".concat(_this.gl_interact_infos.info_node, "/#/r/").concat(_this.gl_interact_infos.public_key);
          }

          _Common["default"].printOut("%s PM2+ activated | Instance Name: %s | Dash: %s", _chalk["default"].green.bold("⇆"), _chalk["default"].bold(_this.gl_interact_infos.machine_name), _chalk["default"].bold(dashboard_url));
        }

        _UX["default"].list(list, sys_infos); //Common.printOut(chalk.white.italic(' Use `pm2 show <id|name>` to get more details about an app'));

      }

      if (_this.Client.daemon_mode == false) {
        _Common["default"].printOut("[--no-daemon] Continue to stream logs");

        _Common["default"].printOut("[--no-daemon] Exit on target PM2 exit pid=" + _fs["default"].readFileSync(conf.PM2_PID_FILE_PATH).toString());

        global["_auto_exit"] = true;
        return _this.streamLogs("all", 0, false, "HH:mm:ss", false);
      } else if (!process.env.TRAVIS && process.env.NODE_ENV != "test" && acted.length > 0 && _commander["default"].attach === true) {
        // if (process.stdout.isTTY) if looking for start logs
        _Common["default"].info("Log streaming apps id: ".concat(_chalk["default"].cyan(acted.join(" ")), ", exit with Ctrl-C or will exit in 10secs")); // setTimeout(() => {
        //   Common.info(`Log streaming exited automatically, run 'pm2 logs' to continue watching logs`)
        //   return that.exitCli(code ? code : conf.SUCCESS_EXIT);
        // }, 10000)


        return acted.forEach(function (proc_name) {
          _this.streamLogs(proc_name, 0, false, null, false);
        });
      } else {
        return _this.exitCli(code ? code : conf.SUCCESS_EXIT);
      }
    }; // Do nothing if PM2 called programmatically and not called from CLI (also in exitCli)


    if (conf.PM2_PROGRAMMATIC && process.env.PM2_USAGE != "CLI") {
      return false;
    } else {
      return _this.Client.executeRemote("getSystemData", {}, function (err, sys_infos) {
        _this.Client.executeRemote("getMonitorData", {}, function (err, proc_list) {
          doList(err, proc_list, sys_infos);
        });
      });
    }
  });
  (0, _defineProperty2["default"])(this, "scale", function (app_name, number, cb) {
    function addProcs(proc, value, cb) {
      (function ex(proc, number) {
        if (number-- === 0) {
          return cb();
        }

        _Common["default"].printOut(conf.PREFIX_MSG + "Scaling up application");

        this.Client.executeRemote("duplicateProcessId", proc.pm2_env.pm_id, ex.bind(this, proc, number));
      })(proc, number);
    }

    var rmProcs = function rmProcs(procs, value, cb) {
      var i = 0;

      var ex = function ex(procs, number) {
        if (number++ === 0) {
          return cb();
        }

        _this._operate("deleteProcessId", procs[i++].pm2_env.pm_id, ex.bind(_this, procs, number));
      };

      ex(procs, number);
    };

    var end = function end() {
      return cb ? cb(null, {
        success: true
      }) : _this.speedList();
    };

    _this.Client.getProcessByName(app_name, function (err, procs) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(conf.ERROR_EXIT);
      }

      if (!procs || procs.length === 0) {
        // Common.printError(conf.PREFIX_MSG_ERR + "Application %s not found", app_name);
        _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "Application %s not found" + app_name).stack);

        return cb ? cb(new Error("App not found")) : _this.exitCli(conf.ERROR_EXIT);
      }

      var proc_number = procs.length;

      if (typeof number === "string" && number.indexOf("+") >= 0) {
        number = parseInt(number, 10);
        return addProcs(procs[0], number, end);
      } else if (typeof number === "string" && number.indexOf("-") >= 0) {
        number = parseInt(number, 10);
        return rmProcs(procs[0], number, end);
      } else {
        number = parseInt(number, 10);
        number = number - proc_number;

        if (number < 0) {
          return rmProcs(procs, number, end);
        } else if (number > 0) {
          return addProcs(procs[0], number, end);
        } else {
          // Common.printError(conf.PREFIX_MSG_ERR + "Nothing to do");
          _Common["default"].printError(new Error(conf.PREFIX_MSG_ERR + "Nothing to do").stack);

          return cb ? cb(new Error("Same process number")) : _this.exitCli(conf.ERROR_EXIT);
        }
      }
    });
  });
  (0, _defineProperty2["default"])(this, "describe", function (pm2_id, cb) {
    var found_proc = [];

    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        _Common["default"].printError("Error retrieving process list: " + err);

        _this.exitCli(conf.ERROR_EXIT);
      }

      list.forEach(function (proc) {
        if (!isNaN(pm2_id) && proc.pm_id == pm2_id || typeof pm2_id === "string" && proc.name == pm2_id) {
          found_proc.push(proc);
        }
      });

      if (found_proc.length === 0) {
        _Common["default"].printError(conf.PREFIX_MSG_WARNING + "%s doesn't exist", pm2_id);

        return cb ? cb(null, []) : _this.exitCli(conf.ERROR_EXIT);
      }

      if (!cb) {
        found_proc.forEach(function (proc) {
          _UX["default"].describe(proc);
        });
      }

      return cb ? cb(null, found_proc) : _this.exitCli(conf.SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "deepUpdate", function (cb) {
    _Common["default"].printOut(conf.PREFIX_MSG + "Updating PM2...");

    var child = (0, _sexec["default"])("npm i -g pm2@latest; pm2 update");
    child.stdout.on("end", function () {
      _Common["default"].printOut(conf.PREFIX_MSG + "PM2 successfully updated");

      cb ? cb(null, {
        success: true
      }) : _this.exitCli(conf.SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "getVersion", function (cb) {
    _this.Client.executeRemote("getVersion", {}, function () {
      return cb ? cb.apply(void 0, arguments) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "launchSysMonitoring", function (cb) {
    _this.set("pm2:sysmonit", "true", function () {
      _this.Client.executeRemote("launchSysMonitoring", {}, function (err) {
        if (err) {
          _Common["default"].err(err);
        } else {
          _Common["default"].log("System Monitoring launched");
        }

        return cb ? cb(err) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    });
  });
  (0, _defineProperty2["default"])(this, "env", function (app_id, cb) {
    // const procs = [];
    var printed = 0;

    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      list.forEach(function (l) {
        if (app_id == l.pm_id) {
          printed++;

          var env = _Common["default"].safeExtend({}, l.pm2_env);

          Object.keys(env).forEach(function (key) {
            console.log("".concat(key, ": ").concat(_chalk["default"].green(env[key])));
          });
        }
      });

      if (printed == 0) {
        _Common["default"].err("Modules with id ".concat(app_id, " not found"));

        return cb ? cb(err) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      return cb ? cb(err) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "report", function () {
    _this.Client.executeRemote("getReport", {}, function (err, report) {
      console.log();
      console.log();
      console.log();
      console.log("```");
      fmt.title("PM2 report");
      fmt.field("Date", new Date());
      fmt.sep();
      fmt.title(_chalk["default"].bold.blue("Daemon"));
      fmt.field("pm2d version", report.pm2_version);
      fmt.field("node version", report.node_version);
      fmt.field("node path", report.node_path);
      fmt.field("argv", report.argv);
      fmt.field("argv0", report.argv0);
      fmt.field("user", report.user);
      fmt.field("uid", report.uid);
      fmt.field("gid", report.gid);
      fmt.field("uptime", (0, _dayjs["default"])(new Date()).diff(report.started_at, "minute") + "min");
      fmt.sep();
      fmt.title(_chalk["default"].bold.blue("CLI"));
      fmt.field("local pm2", _package["default"].version);
      fmt.field("node version", process.versions.node);
      fmt.field("node path", process.env["_"] || "not found");
      fmt.field("argv", process.argv);
      fmt.field("argv0", process.argv0);
      fmt.field("user", process.env.USER || process.env.LNAME || process.env.USERNAME);

      if (_constants["default"].IS_WINDOWS === false && process.geteuid) {
        fmt.field("uid", process.geteuid());
      }

      if (_constants["default"].IS_WINDOWS === false && process.getegid) {
        fmt.field("gid", process.getegid());
      }

      var os = require("os");

      fmt.sep();
      fmt.title(_chalk["default"].bold.blue("System info"));
      fmt.field("arch", os.arch());
      fmt.field("platform", os.platform());
      fmt.field("type", os.type());
      fmt.field("cpus", os.cpus()[0].model);
      fmt.field("cpus nb", Object.keys(os.cpus()).length);
      fmt.field("freemem", os.freemem());
      fmt.field("totalmem", os.totalmem());
      fmt.field("home", os.homedir());

      _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
        fmt.sep();
        fmt.title(_chalk["default"].bold.blue("PM2 list"));

        _UX["default"].list(list, _this.gl_interact_infos);

        fmt.sep();
        fmt.title(_chalk["default"].bold.blue("Daemon logs"));

        _Log["default"].tail([{
          path: _constants["default"].PM2_LOG_FILE_PATH,
          app_name: "PM2",
          type: "PM2"
        }], 20, false, function () {
          console.log("```");
          console.log();
          console.log();
          console.log(_chalk["default"].bold.green("Please copy/paste the above report in your issue on https://github.com/Unitech/pm2/issues"));
          console.log();
          console.log();

          _this.exitCli(_constants["default"].SUCCESS_EXIT);
        });
      });
    });
  });
  (0, _defineProperty2["default"])(this, "getPID", function (app_name, cb) {
    if (typeof app_name === "function") {
      cb = app_name;
      app_name = null;
    }

    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        // Common.printError(cst.PREFIX_MSG_ERR + err);
        _Common["default"].printError(new Error(_constants["default"].PREFIX_MSG_ERR + err).stack);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      var pids = [];
      list.forEach(function (app) {
        if (!app_name || app_name == app.name) {
          pids.push(app.pid);
        }
      });

      if (!cb) {
        _Common["default"].printOut(pids.join("\n"));

        return _this.exitCli(_constants["default"].SUCCESS_EXIT);
      }

      return cb(null, pids);
    });
  });
  (0, _defineProperty2["default"])(this, "profile", function (type, time, cb) {
    var dayjs = require("dayjs");

    var cmd;

    if (type == "cpu") {
      cmd = {
        ext: ".cpuprofile",
        action: "profileCPU"
      };
    }

    if (type == "mem") {
      cmd = {
        ext: ".heapprofile",
        action: "profileMEM"
      };
    }

    var file = _path["default"].join(process.cwd(), dayjs().format("dd-HH:mm:ss") + cmd.ext);

    time = time || 10000;
    console.log("Starting ".concat(cmd.action, " profiling for ").concat(time, "ms..."));

    _this.Client.executeRemote(cmd.action, {
      pwd: file,
      timeout: time
    }, function (err) {
      if (err) {
        console.error(err);
        return _this.exitCli(1);
      }

      console.log("Profile done in ".concat(file));
      return cb ? cb(err) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "boilerplate", function (cb) {
    var projects = [];

    var enquirer = require("enquirer");

    _fs["default"].readdir(_path["default"].join(__dirname, "../../templates/sample-apps"), function (err, items) {
      require("async").forEach(items, function (app, next) {
        var fp = _path["default"].join(__dirname, "../../templates/sample-apps", app);

        _fs["default"].readFile(_path["default"].join(fp, "package.json"), "utf8", function (err, dt) {
          var meta = JSON.parse(dt);
          meta.fullpath = fp;
          meta.folder_name = app;
          projects.push(meta);
          next();
        });
      }, function () {
        var prompt = new enquirer.Select({
          name: "boilerplate",
          message: "Select a boilerplate",
          choices: projects.map(function (p, i) {
            return {
              message: "".concat(_chalk["default"].bold.blue(p.name), " ").concat(p.description),
              value: "".concat(i)
            };
          })
        });
        prompt.run().then(function (answer) {
          var p = projects[parseInt(answer)];
          basicMDHighlight(_fs["default"].readFileSync(_path["default"].join(p.fullpath, "README.md")).toString());
          console.log(_chalk["default"].bold(">> Project copied inside folder ./".concat(p.folder_name, "/\n")));
          (0, _copydirSync["default"])(p.fullpath, _path["default"].join(process.cwd(), p.folder_name));

          _this.start(_path["default"].join(p.fullpath, "ecosystem.config.js"), {
            cwd: p.fullpath
          }, function (err) {
            return cb ? cb(err) : _this.speedList(_constants["default"].SUCCESS_EXIT);
          });
        })["catch"](function (e) {
          return cb ? cb(e) : _this.speedList(_constants["default"].SUCCESS_EXIT);
        });
      });
    });
  });
  (0, _defineProperty2["default"])(this, "sendLineToStdin", function (pm_id, line, separator, cb) {
    if (!cb && typeof separator == "function") {
      cb = separator;
      separator = null;
    }

    var packet = {
      pm_id: pm_id,
      line: line + (separator || "\n")
    };

    _this.Client.executeRemote("sendLineToStdin", packet, function (err, res) {
      if (err) {
        // Common.printError(cst.PREFIX_MSG_ERR + err);
        _Common["default"].printError(new Error(_constants["default"].PREFIX_MSG_ERR + err).stack);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      return cb ? cb(null, res) : _this.speedList();
    });
  });
  (0, _defineProperty2["default"])(this, "attach", function (pm_id, separator, cb) {
    var readline = require("readline");

    if (isNaN(pm_id)) {
      _Common["default"].printError("pm_id must be a process number (not a process name)");

      return cb ? cb(_Common["default"].retErr("pm_id must be number")) : _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    if (typeof separator == "function") {
      cb = separator;
      separator = null;
    }

    var rl = readline.createInterface({
      input: process.stdin,
      output: process.stdout
    });
    rl.on("close", function () {
      return cb ? cb() : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });

    _this.Client.launchBus(function (err, bus, socket) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      bus.on("log:*", function (type, packet) {
        if (packet.process.pm_id !== parseInt(pm_id)) {
          return;
        }

        process.stdout.write(packet.data);
      });
    });

    rl.on("line", function (line) {
      _this.sendLineToStdin(pm_id, line, separator, function () {// do nothing
      });
    });
  });
  (0, _defineProperty2["default"])(this, "sendDataToProcessId", function (proc_id, packet, cb) {
    if ((0, _typeof2["default"])(proc_id) === "object" && typeof packet === "function") {
      // the proc_id is packet.
      cb = packet;
      packet = proc_id;
    } else {
      packet.id = proc_id;
    }

    _this.Client.executeRemote("sendDataToProcessId", packet, function (err, res) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      _Common["default"].printOut("successfully sent data to process");

      return cb ? cb(null, res) : _this.speedList();
    });
  });
  (0, _defineProperty2["default"])(this, "msgProcess", function (opts, cb) {
    _this.Client.executeRemote("msgProcess", opts, cb);
  });
  (0, _defineProperty2["default"])(this, "trigger", function (pm_id, action_name, params, cb) {
    if (typeof params === "function") {
      cb = params;
      params = null;
    }

    var cmd = {
      msg: action_name
    };
    var counter = 0;
    var process_wait_count = 0;
    var results = [];

    if (params) {
      cmd.opts = params;
    }

    if (isNaN(pm_id)) {
      cmd.name = pm_id;
    } else {
      cmd.id = pm_id;
    }

    _this.launchBus(function (err, bus) {
      bus.on("axm:reply", function (ret) {
        if (ret.process.name == pm_id || ret.process.pm_id == pm_id || ret.process.namespace == pm_id || pm_id == "all") {
          results.push(ret);

          _Common["default"].printOut("[%s:%s:%s]=%j", ret.process.name, ret.process.pm_id, ret.process.namespace, ret.data["return"]);

          if (++counter == process_wait_count) {
            return cb ? cb(null, results) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
          }
        }
      });

      _this.msgProcess(cmd, function (err, data) {
        if (err) {
          _Common["default"].printError(err);

          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        if (data.process_count == 0) {
          _Common["default"].printError("Not any process has received a command (offline or unexistent)");

          return cb ? cb(_Common["default"].retErr("Unknown process")) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        process_wait_count = data.process_count;

        _Common["default"].printOut(_chalk["default"].bold("%s processes have received command %s"), data.process_count, action_name);
      });
    });
  });
  (0, _defineProperty2["default"])(this, "sendSignalToProcessName", function (signal, process_name, cb) {
    _this.Client.executeRemote("sendSignalToProcessName", {
      signal: signal,
      process_name: process_name
    }, function (err, list) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      _Common["default"].printOut("successfully sent signal %s to process name %s", signal, process_name);

      return cb ? cb(null, list) : _this.speedList();
    });
  });
  (0, _defineProperty2["default"])(this, "sendSignalToProcessId", function (signal, process_id, cb) {
    _this.Client.executeRemote("sendSignalToProcessId", {
      signal: signal,
      process_id: process_id
    }, function (err, list) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      _Common["default"].printOut("successfully sent signal %s to process id %s", signal, process_id);

      return cb ? cb(null, list) : _this.speedList();
    });
  });
  (0, _defineProperty2["default"])(this, "autoinstall", function (cb) {
    var filepath = _path["default"].resolve(_path["default"].dirname(module.filename), "../Sysinfo/ServiceDetection/ServiceDetection.js");

    _this.start(filepath, function (err, res) {
      if (err) {
        // Common.printError(cst.PREFIX_MSG_ERR + "Error while trying to serve : " + err.message || err);
        _Common["default"].printError(_constants["default"].PREFIX_MSG_ERR + "Error while trying to serve : " + err.stack || err);

        return cb ? cb(err) : _this.speedList(_constants["default"].ERROR_EXIT);
      }

      return cb ? cb(null) : _this.speedList();
    });
  });
  (0, _defineProperty2["default"])(this, "serve", function (target_path, port, opts, commander, cb) {
    var servePort = process.env.PM2_SERVE_PORT || port || 8080;

    var servePath = _path["default"].resolve(process.env.PM2_SERVE_PATH || target_path || ".");

    var filepath = _path["default"].resolve(_path["default"].dirname(module.filename), "./Serve.js");

    if (typeof commander.name === "string") {
      opts.name = commander.name;
    } else {
      opts.name = "static-page-server-" + servePort;
    }

    if (!opts.env) {
      opts.env = {};
    }

    opts.env.PM2_SERVE_PORT = servePort;
    opts.env.PM2_SERVE_PATH = servePath;
    opts.env.PM2_SERVE_SPA = opts.spa;

    if (opts.basicAuthUsername && opts.basicAuthPassword) {
      opts.env.PM2_SERVE_BASIC_AUTH = "true";
      opts.env.PM2_SERVE_BASIC_AUTH_USERNAME = opts.basicAuthUsername;
      opts.env.PM2_SERVE_BASIC_AUTH_PASSWORD = opts.basicAuthPassword;
    }

    if (opts.monitor) {
      opts.env.PM2_SERVE_MONITOR = opts.monitor;
    }

    opts.cwd = servePath;

    _this.start(filepath, opts, function (err, res) {
      if (err) {
        // Common.printError(cst.PREFIX_MSG_ERR + "Error while trying to serve : " + err.message || err);
        _Common["default"].printError(_constants["default"].PREFIX_MSG_ERR + "Error while trying to serve : " + err.stack || err);

        return cb ? cb(err) : _this.speedList(_constants["default"].ERROR_EXIT);
      }

      _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Serving " + servePath + " on port " + servePort);

      return cb ? cb(null, res) : _this.speedList();
    });
  });
  (0, _defineProperty2["default"])(this, "ping", function (cb) {
    _this.Client.executeRemote("ping", {}, function (err, res) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(new Error(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      _Common["default"].printOut(res);

      return cb ? cb(null, res) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "remote", function (command, opts, cb) {
    _this[command](opts.name, function (err_cmd, ret) {
      if (err_cmd) {
        console.error(err_cmd);
      }

      console.log("Command %s finished", command);
      return cb(err_cmd, ret);
    });
  });
  (0, _defineProperty2["default"])(this, "remoteV2", function (command, opts, cb) {
    if (_this[command].length == 1) {
      return _this[command](cb);
    }

    opts.args.push(cb);
    return _this[command](opts.args);
  });
  (0, _defineProperty2["default"])(this, "generateSample", function (mode) {
    var templatePath;

    if (mode == "simple") {
      templatePath = _path["default"].join(_constants["default"].TEMPLATE_FOLDER, _constants["default"].APP_CONF_TPL_SIMPLE);
    } else {
      templatePath = _path["default"].join(_constants["default"].TEMPLATE_FOLDER, _constants["default"].APP_CONF_TPL);
    }

    var sample = _fs["default"].readFileSync(templatePath);

    var dt = sample.toString();
    var f_name = "ecosystem.config.js";
    var pwd = process.env.PWD || process.cwd();

    try {
      _fs["default"].writeFileSync(_path["default"].join(pwd, f_name), dt);
    } catch (e) {
      console.error(e.stack || e);
      return _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    _Common["default"].printOut("File %s generated", _path["default"].join(pwd, f_name));

    _this.exitCli(_constants["default"].SUCCESS_EXIT);
  });
  (0, _defineProperty2["default"])(this, "dashboard", function (cb) {
    if (cb) {
      return cb(new Error("Dashboard cant be called programmatically"));
    }

    _Dashboard["default"].init();

    _this.Client.launchBus(function (err, bus) {
      if (err) {
        console.error("Error launchBus: " + err);

        _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      bus.on("log:*", function (type, data) {
        _Dashboard["default"].log(type, data);
      });
    });

    process.on("SIGINT", function () {
      this.Client.disconnectBus(function () {
        process.exit(_constants["default"].SUCCESS_EXIT);
      });
    });

    var refreshDashboard = function refreshDashboard() {
      _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
        if (err) {
          console.error("Error retrieving process list: " + err);

          _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        _Dashboard["default"].refresh(list);

        setTimeout(function () {
          refreshDashboard();
        }, 800);
      });
    };

    refreshDashboard();
  });
  (0, _defineProperty2["default"])(this, "monit", function (cb) {
    if (cb) {
      return cb(new Error("Monit cant be called programmatically"));
    }

    _Monit["default"].init();

    var launchMonitor = function launchMonitor() {
      _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
        if (err) {
          console.error("Error retrieving process list: " + err);

          _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        _Monit["default"].refresh(list);

        setTimeout(function () {
          launchMonitor();
        }, 400);
      });
    };

    launchMonitor();
  });
  (0, _defineProperty2["default"])(this, "inspect", function (app_name, cb) {
    if (_semver["default"].satisfies(process.versions.node, ">= 8.0.0")) {
      _this.trigger(app_name, "internal:inspect", function (err, res) {
        if (res && res[0]) {
          if (res[0].data["return"] === "") {
            _Common["default"].printOut("Inspect disabled on ".concat(app_name));
          } else {
            _Common["default"].printOut("Inspect enabled on ".concat(app_name, " => go to chrome : chrome://inspect !!!"));
          }
        } else {
          _Common["default"].printOut("Unable to activate inspect mode on ".concat(app_name, " !!!"));
        }

        _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    } else {
      _Common["default"].printOut("Inspect is available for node version >=8.x !");

      _this.exitCli(_constants["default"].SUCCESS_EXIT);
    }
  });
  (0, _defineProperty2["default"])(this, "deploy", function (file, commands, cb) {
    if (file == "help") {
      deployHelper();
      return cb ? cb() : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    }

    var args = commands.rawArgs;
    var env;
    args.splice(0, args.indexOf("deploy") + 1); // Find ecosystem file by default

    if (!_Common["default"].isConfigFile(file)) {
      env = args[0];
      var defaultConfigNames = ["ecosystem.config.js", "ecosystem.json", "ecosystem.json5", "package.json"];
      file = _Utility["default"].whichFileExists(defaultConfigNames);

      if (!file) {
        _Common["default"].printError("Not any default deployment file exists." + " Allowed default config file names are: " + defaultConfigNames.join(", "));

        return cb ? cb("Not any default ecosystem file present") : _this.exitCli(_constants["default"].ERROR_EXIT);
      }
    } else {
      env = args[1];
    }

    var json_conf = null;

    try {
      json_conf = _Common["default"].parseConfig(_fs["default"].readFileSync(file), file);
    } catch (e) {
      _Common["default"].printError(e);

      return cb ? cb(e) : _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    if (!env) {
      deployHelper();
      return cb ? cb() : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    }

    if (!json_conf.deploy || !json_conf.deploy[env]) {
      _Common["default"].printError("%s environment is not defined in %s file", env, file);

      return cb ? cb("%s environment is not defined in %s file") : _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    if (!json_conf.deploy[env]["post-deploy"]) {
      json_conf.deploy[env]["post-deploy"] = "pm2t startOrRestart " + file + " --env " + env;
    }

    _pm2tDeploy["default"].deployForEnv(json_conf.deploy, env, args, function (err, data) {
      if (err) {
        _Common["default"].printError("Deploy failed");

        _Common["default"].printError(err.message || err);

        return cb ? cb(err) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      _Common["default"].printOut("--> Success");

      return cb ? cb(null, data) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "install", function (module_name, opts, cb) {
    if (typeof opts == "function") {
      cb = opts;
      opts = {};
    }

    _Modularizer["default"].install(_this, module_name, opts, function (err, data) {
      if (err) {
        // Common.printError(cst.PREFIX_MSG_ERR + (err.message || err));
        _Common["default"].printError(_constants["default"].PREFIX_MSG_ERR + (err.stack || err));

        return cb ? cb(_Common["default"].retErr(err)) : _this.speedList(_constants["default"].ERROR_EXIT);
      }

      return cb ? cb(null, data) : _this.speedList(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "uninstall", function (module_name, cb) {
    _Modularizer["default"].uninstall(_this, module_name, function (err, data) {
      if (err) {
        return cb ? cb(_Common["default"].retErr(err)) : _this.speedList(_constants["default"].ERROR_EXIT);
      }

      return cb ? cb(null, data) : _this.speedList(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "launchAll", function (CLI, cb) {
    _Modularizer["default"].launchModules(CLI, cb);
  });
  (0, _defineProperty2["default"])(this, "package", function (module_path, cb) {
    _Modularizer["default"]["package"](_this, module_path, function (err, res) {
      if (err) {
        _Common["default"].errMod(err);

        return cb ? cb(err) : _this.exitCli(1);
      }

      _Common["default"].logMod("Module packaged in ".concat(res.path));

      return cb ? cb(err) : _this.exitCli(0);
    });
  });
  (0, _defineProperty2["default"])(this, "publish", function (folder, opts, cb) {
    _Modularizer["default"].publish(_this, folder, opts, function (err, data) {
      if (err) {
        return cb ? cb(_Common["default"].retErr(err)) : _this.speedList(_constants["default"].ERROR_EXIT);
      }

      return cb ? cb(null, data) : _this.speedList(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "generateModuleSample", function (app_name, cb) {
    _Modularizer["default"].generateSample(app_name, function (err, data) {
      if (err) {
        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      return cb ? cb(null, data) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "deleteModule", function (module_name, cb) {
    var found_proc = [];

    _this.Client.getAllProcess(function (err, procs) {
      if (err) {
        _Common["default"].printError("Error retrieving process list: " + err);

        return cb(_Common["default"].retErr(err));
      }

      procs.forEach(function (proc) {
        if (proc.pm2_env.name == module_name && proc.pm2_env.pmx_module) {
          found_proc.push(proc.pm_id);
        }
      });

      if (found_proc.length == 0) {
        return cb();
      }

      _this._operate("deleteProcessId", found_proc[0], function (err) {
        if (err) {
          return cb(_Common["default"].retErr(err));
        }

        _Common["default"].printOut("In memory process deleted");

        return cb();
      });
    });
  });
  (0, _defineProperty2["default"])(this, "get", function (key, cb) {
    if (!key || key == "all") {
      displayConf(function (err, data) {
        if (err) {
          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        return cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
      return false;
    }

    _Configuration["default"].get(key, function (err, data) {
      if (err) {
        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      } // pm2 conf module-name


      if (key.indexOf(":") === -1 && key.indexOf(".") === -1) {
        displayConf(key, function () {
          console.log("Modules configuration. Copy/Paste line to edit values.");
          return cb ? cb(null, {
            success: true
          }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
        });
        return false;
      } // pm2 conf module-name:key


      var module_name, key_name;

      if (key.indexOf(":") > -1) {
        module_name = key.split(":")[0];
        key_name = key.split(":")[1];
      } else if (key.indexOf(".") > -1) {
        module_name = key.split(".")[0];
        key_name = key.split(".")[1];
      }

      _Common["default"].printOut("Value for module " + _chalk["default"].blue(module_name), "key " + _chalk["default"].blue(key_name) + ": " + _chalk["default"].bold.green(data));

      return cb ? cb(null, {
        success: true
      }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "set", function (key, value, cb) {
    if (!key) {
      interactiveConfigEdit(function (err) {
        if (err) {
          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        return cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
      return false;
    }
    /**
     * Set value
     */


    _Configuration["default"].set(key, value, function (err) {
      if (err) {
        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      var values = [];

      if (key.indexOf(".") > -1) {
        values = key.split(".");
      }

      if (key.indexOf(":") > -1) {
        values = key.split(":");
      }

      if (values && values.length > 1) {
        // The first element is the app name (module_conf.json)
        var app_name = values[0];
        process.env.PM2_PROGRAMMATIC = "true";

        _this.restart(app_name, {
          updateEnv: true
        }, function (err, data) {
          process.env.PM2_PROGRAMMATIC = "false";

          if (!err) {
            _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Module %s restarted", app_name);
          }

          _Common["default"].log("Setting changed");

          displayConf(app_name, function () {
            return cb ? cb(null, {
              success: true
            }) : this.exitCli(_constants["default"].SUCCESS_EXIT);
          });
        });

        return false;
      }

      displayConf(null, function () {
        return cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    });
  });
  (0, _defineProperty2["default"])(this, "multiset", function (serial, cb) {
    _Configuration["default"].multiset(serial, function (err, data) {
      if (err) {
        return cb ? cb({
          success: false,
          err: err
        }) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      var values = [];
      var key = serial.match(/(?:[^ "]+|"[^"]*")+/g)[0];

      if (key.indexOf(".") > -1) {
        values = key.split(".");
      }

      if (key.indexOf(":") > -1) {
        values = key.split(":");
      }

      var app_name;

      if (values && values.length > 1) {
        // The first element is the app name (module_conf.json)
        app_name = values[0];
        process.env.PM2_PROGRAMMATIC = "true";

        _this.restart(app_name, {
          updateEnv: true
        }, function (err, data) {
          process.env.PM2_PROGRAMMATIC = "false";

          if (!err) {
            _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Module %s restarted", app_name);
          }

          displayConf(app_name, function () {
            return cb ? cb(null, {
              success: true
            }) : this.exitCli(_constants["default"].SUCCESS_EXIT);
          });
        });

        return false;
      }

      displayConf(app_name, function () {
        return cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    });
  });
  (0, _defineProperty2["default"])(this, "unset", function (key, cb) {
    _Configuration["default"].unset(key, function (err) {
      if (err) {
        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      displayConf(function () {
        cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    });
  });
  (0, _defineProperty2["default"])(this, "conf", function (key, value, cb) {
    if (typeof value === "function") {
      cb = value;
      value = null;
    } // If key + value = set


    if (key && value) {
      _this.set(key, value, function (err) {
        if (err) {
          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        return cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    } else if (key) {
      // If only key = get
      _this.get(key, function (err, data) {
        if (err) {
          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        return cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    } else {
      interactiveConfigEdit(function (err) {
        if (err) {
          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        return cb ? cb(null, {
          success: true
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });
    }
  });
  (0, _defineProperty2["default"])(this, "_pull", function (opts, cb) {
    var process_name = opts.process_name;
    var reload_type = opts.action;
    printOut(_constants["default"].PREFIX_MSG + "Updating repository for process name %s", process_name);

    _this.Client.getProcessByNameOrId(process_name, function (err, processes) {
      if (err || processes.length === 0) {
        printError("No processes with this name or id : %s", process_name);
        return cb ? cb({
          msg: "Process not found: " + process_name
        }) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      var proc = processes[0];

      if (!proc.pm2_env.versioning) {
        printOut(_constants["default"].PREFIX_MSG + "No versioning system found for process %s", process_name);
        return cb ? cb({
          success: false,
          msg: "No versioning system found for process"
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      }

      require("vizion").update({
        folder: proc.pm2_env.versioning.repo_path
      }, function (err, meta) {
        if (err !== null) {
          return cb ? cb({
            msg: err
          }) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        if (meta.success === true) {
          getPostUpdateCmds(proc.pm2_env.versioning.repo_path, process_name, function (command_list) {
            execCommands(proc.pm2_env.versioning.repo_path, command_list, function (err, res) {
              if (err !== null) {
                printError(err);
                return cb ? cb({
                  msg: meta.output + err
                }) : _this.exitCli(_constants["default"].ERROR_EXIT);
              } else {
                printOut(_constants["default"].PREFIX_MSG + "Process successfully updated %s", process_name);
                printOut(_constants["default"].PREFIX_MSG + "Current commit %s", meta.current_revision);
                return _this[reload_type](process_name, function (err, procs) {
                  if (err && cb) {
                    return cb(err);
                  }

                  if (err) {
                    console.error(err);
                  }

                  return cb ? cb(null, meta.output + res) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
                });
              }
            });
          });
        } else {
          printOut(_constants["default"].PREFIX_MSG + "Already up-to-date or an error occured for app: %s", process_name);
          return cb ? cb({
            success: false,
            msg: "Already up to date"
          }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
        }

        return false;
      });

      return false;
    });
  });
  (0, _defineProperty2["default"])(this, "pullCommitId", function (process_name, commit_id, cb) {
    var reload_type = "reload";
    printOut(_constants["default"].PREFIX_MSG + "Updating repository for process name %s", process_name);

    _this.Client.getProcessByNameOrId(process_name, function (err, processes) {
      if (err || processes.length === 0) {
        printError("No processes with this name or id : %s", process_name);
        return cb ? cb({
          msg: "Process not found: " + process_name
        }) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      var proc = processes[0];

      if (proc.pm2_env.versioning) {
        require("vizion").isUpToDate({
          folder: proc.pm2_env.versioning.repo_path
        }, function (err, meta) {
          if (err !== null) {
            return cb ? cb({
              msg: err
            }) : _this.exitCli(_constants["default"].ERROR_EXIT);
          }

          require("vizion").revertTo({
            revision: commit_id,
            folder: proc.pm2_env.versioning.repo_path
          }, function (err2, meta2) {
            if (!err2 && meta2.success) {
              getPostUpdateCmds(proc.pm2_env.versioning.repo_path, process_name, function (command_list) {
                execCommands(proc.pm2_env.versioning.repo_path, command_list, function (err, res) {
                  if (err !== null) {
                    printError(err);
                    return cb ? cb({
                      msg: err
                    }) : _this.exitCli(_constants["default"].ERROR_EXIT);
                  } else {
                    printOut(_constants["default"].PREFIX_MSG + "Process successfully updated %s", process_name);
                    printOut(_constants["default"].PREFIX_MSG + "Current commit %s", commit_id);
                    return _this[reload_type](process_name, cb);
                  }
                });
              });
            } else {
              printOut(_constants["default"].PREFIX_MSG + "Already up-to-date or an error occured: %s", process_name);
              return cb ? cb(null, {
                success: meta.success
              }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
            }
          });
        });
      } else {
        printOut(_constants["default"].PREFIX_MSG + "No versioning system found for process %s", process_name);
        return cb ? cb(null, {
          success: false
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      }
    });
  });
  (0, _defineProperty2["default"])(this, "backward", function (process_name, cb) {
    printOut(_constants["default"].PREFIX_MSG + "Downgrading to previous commit repository for process name %s", process_name);

    _this.Client.getProcessByNameOrId(process_name, function (err, processes) {
      if (err || processes.length === 0) {
        printError("No processes with this name or id : %s", process_name);
        return cb ? cb({
          msg: "Process not found: " + process_name
        }) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      var proc = processes[0]; // in case user searched by id/pid

      process_name = proc.name;

      if (proc.pm2_env.versioning === undefined || proc.pm2_env.versioning === null) {
        return cb({
          msg: "Versioning unknown"
        });
      }

      require("vizion").prev({
        folder: proc.pm2_env.versioning.repo_path
      }, function (err, meta) {
        if (err) {
          return cb ? cb({
            msg: err,
            data: meta
          }) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        if (meta.success !== true) {
          printOut(_constants["default"].PREFIX_MSG + "No versioning system found for process %s", process_name);
          return cb ? cb({
            msg: err,
            data: meta
          }) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        getPostUpdateCmds(proc.pm2_env.versioning.repo_path, process_name, function (command_list) {
          execCommands(proc.pm2_env.versioning.repo_path, command_list, function (err, res) {
            if (err !== null) {
              require("vizion").next({
                folder: proc.pm2_env.versioning.repo_path
              }, function (err2, meta2) {
                printError(err);
                return cb ? cb({
                  msg: meta.output + err
                }) : _this.exitCli(_constants["default"].ERROR_EXIT);
              });

              return false;
            }

            printOut(_constants["default"].PREFIX_MSG + "Process successfully updated %s", process_name);
            printOut(_constants["default"].PREFIX_MSG + "Current commit %s", meta.current_revision);

            _this.reload(process_name, function (err, procs) {
              if (err) {
                return cb(err);
              }

              return cb ? cb(null, meta.output + res) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
            });
          });
        });
      });
    });
  });
  (0, _defineProperty2["default"])(this, "forward", function (process_name, cb) {
    printOut(_constants["default"].PREFIX_MSG + "Updating to next commit repository for process name %s", process_name);

    _this.Client.getProcessByNameOrId(process_name, function (err, processes) {
      if (err || processes.length === 0) {
        printError("No processes with this name or id: %s", process_name);
        return cb ? cb({
          msg: "Process not found: " + process_name
        }) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      var proc = processes[0]; // in case user searched by id/pid

      process_name = proc.name;

      if (proc.pm2_env.versioning) {
        require("vizion").next({
          folder: proc.pm2_env.versioning.repo_path
        }, function (err, meta) {
          if (err !== null) {
            return cb ? cb({
              msg: err
            }) : _this.exitCli(_constants["default"].ERROR_EXIT);
          }

          if (meta.success === true) {
            getPostUpdateCmds(proc.pm2_env.versioning.repo_path, process_name, function (command_list) {
              execCommands(proc.pm2_env.versioning.repo_path, command_list, function (err, res) {
                if (err !== null) {
                  require("vizion").prev({
                    folder: proc.pm2_env.versioning.repo_path
                  }, function (err2, meta2) {
                    printError(err);
                    return cb ? cb({
                      msg: meta.output + err
                    }) : _this.exitCli(_constants["default"].ERROR_EXIT);
                  });
                } else {
                  printOut(_constants["default"].PREFIX_MSG + "Process successfully updated %s", process_name);
                  printOut(_constants["default"].PREFIX_MSG + "Current commit %s", meta.current_revision);

                  _this.reload(process_name, function (err, procs) {
                    if (err) {
                      return cb(err);
                    }

                    return cb ? cb(null, meta.output + res) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
                  });
                }
              });
            });
          } else {
            printOut(_constants["default"].PREFIX_MSG + "Already up-to-date or an error occured: %s", process_name);
            return cb ? cb(null, {
              success: meta.success
            }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
          }
        });
      } else {
        printOut(_constants["default"].PREFIX_MSG + "No versioning system found for process %s", process_name);
        return cb ? cb({
          success: false,
          msg: "No versioning system found"
        }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      }
    });
  });
  (0, _defineProperty2["default"])(this, "pullAndRestart", function (process_name, cb) {
    _this._pull({
      process_name: process_name,
      action: "reload"
    }, cb);
  });
  (0, _defineProperty2["default"])(this, "pullAndReload", function (process_name, cb) {
    _this._pull({
      process_name: process_name,
      action: "reload"
    }, cb);
  });
  (0, _defineProperty2["default"])(this, "_pullCommitId", function (opts, cb) {
    _this.pullCommitId(opts.pm2_name, opts.commit_id, cb);
  });
  (0, _defineProperty2["default"])(this, "uninstallStartup", function (platform, opts, cb) {
    var commands;
    var actual_platform = detectInitSystem();
    var user = opts.user || process.env.USER || process.env.LOGNAME; // Use LOGNAME on Solaris-like systems

    var service_name = opts.serviceName || "pm2-" + user;
    var openrc_service_name = "pm2";
    var launchd_service_name = opts.serviceName || "pm2." + user;

    if (!platform) {
      platform = actual_platform;
    } else if (actual_platform && actual_platform !== platform) {
      _Common["default"].printOut("-----------------------------------------------------------");

      _Common["default"].printOut(" PM2 detected " + actual_platform + " but you precised " + platform);

      _Common["default"].printOut(" Please verify that your choice is indeed your init system");

      _Common["default"].printOut(" If you arent sure, just run : pm2 startup");

      _Common["default"].printOut("-----------------------------------------------------------");
    }

    if (platform === null) {
      throw new Error("Init system not found");
    }

    if (!cb) {
      cb = function cb(err, data) {
        if (err) {
          return _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        return _this.exitCli(_constants["default"].SUCCESS_EXIT);
      };
    }

    if (process.getuid() != 0) {
      return isNotRoot("unsetup", platform, opts, cb);
    }

    if (_fs["default"].existsSync("/etc/init.d/pm2-init.sh")) {
      platform = "oldsystem";
    }

    var destination;

    switch (platform) {
      case "systemd":
        commands = ["systemctl stop " + service_name, "systemctl disable " + service_name, "rm /etc/systemd/system/" + service_name + ".service"];
        break;

      case "systemv":
        commands = ["chkconfig " + service_name + " off", "rm /etc/init.d/" + service_name];
        break;

      case "oldsystem":
        _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Disabling and deleting old startup system");

        commands = ["update-rc.d pm2-init.sh disable", "update-rc.d -f pm2-init.sh remove", "rm /etc/init.d/pm2-init.sh"];
        break;

      case "openrc":
        service_name = openrc_service_name;
        commands = ["/etc/init.d/" + service_name + " stop", "rc-update delete " + service_name + " default", "rm /etc/init.d/" + service_name];
        break;

      case "upstart":
        commands = ["update-rc.d " + service_name + " disable", "update-rc.d -f " + service_name + " remove", "rm /etc/init.d/" + service_name];
        break;

      case "launchd":
        destination = _path["default"].join(process.env.HOME, "Library/LaunchAgents/" + launchd_service_name + ".plist");
        commands = ["launchctl remove " + launchd_service_name + " || true", "rm " + destination];
        break;

      case "rcd":
        service_name = opts.serviceName || "pm2_" + user;
        commands = ["/usr/local/etc/rc.d/" + service_name + " stop", "sysrc -x " + service_name + "_enable", "rm /usr/local/etc/rc.d/" + service_name];
        break;

      case "rcd-openbsd":
        service_name = opts.serviceName || "pm2_" + user;
        destination = _path["default"].join("/etc/rc.d", service_name);
        commands = ["rcctl stop " + service_name, "rcctl disable " + service_name, "rm " + destination];
        break;

      case "smf":
        service_name = opts.serviceName || "pm2_" + user;
        commands = ["svcadm disable " + service_name, "svccfg delete -f " + service_name];
    }

    (0, _sexec["default"])(commands.join("&& "), function (code, stdout, stderr) {
      _Common["default"].printOut(stdout);

      _Common["default"].printOut(stderr);

      if (code == 0) {
        _Common["default"].printOut(_constants["default"].PREFIX_MSG + _chalk["default"].bold("Init file disabled."));
      } else {
        _Common["default"].printOut(_constants["default"].ERROR_MSG + _chalk["default"].bold("Return code : " + code));
      }

      cb(null, {
        commands: commands,
        platform: platform
      });
    });
  });
  (0, _defineProperty2["default"])(this, "startup", function (platform, opts, cb) {
    var actual_platform = detectInitSystem();
    var user = opts.user || process.env.USER || process.env.LOGNAME; // Use LOGNAME on Solaris-like systems

    var service_name = opts.serviceName || "pm2-" + user;
    var openrc_service_name = "pm2";
    var launchd_service_name = opts.serviceName || "pm2." + user;

    if (!platform) {
      platform = actual_platform;
    } else if (actual_platform && actual_platform !== platform) {
      _Common["default"].printOut("-----------------------------------------------------------");

      _Common["default"].printOut(" PM2 detected " + actual_platform + " but you precised " + platform);

      _Common["default"].printOut(" Please verify that your choice is indeed your init system");

      _Common["default"].printOut(" If you arent sure, just run : pm2 startup");

      _Common["default"].printOut("-----------------------------------------------------------");
    }

    if (platform == null) {
      throw new Error("Init system not found");
    }

    if (!cb) {
      cb = function cb(err, data) {
        if (err) {
          return _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        return _this.exitCli(_constants["default"].SUCCESS_EXIT);
      };
    }

    if (process.getuid() != 0) {
      return isNotRoot("setup", platform, opts, cb);
    }

    var destination;
    var commands;
    var template;

    function getTemplate(type) {
      return _fs["default"].readFileSync(_path["default"].join(__dirname, "..", "templates/init-scripts", type + ".tpl"), {
        encoding: "utf8"
      });
    }

    switch (platform) {
      case "ubuntu":
      case "centos":
      case "arch":
      case "oracle":
      case "systemd":
        if (opts.waitIp) {
          template = getTemplate("systemd-online");
        } else {
          template = getTemplate("systemd");
        }

        destination = "/etc/systemd/system/" + service_name + ".service";
        commands = ["systemctl enable " + service_name];
        break;

      case "ubuntu14":
      case "ubuntu12":
      case "upstart":
        template = getTemplate("upstart");
        destination = "/etc/init.d/" + service_name;
        commands = ["chmod +x " + destination, "mkdir -p /var/lock/subsys", "touch /var/lock/subsys/" + service_name, "update-rc.d " + service_name + " defaults"];
        break;

      case "systemv":
      case "amazon":
      case "centos6":
        template = getTemplate("upstart");
        destination = "/etc/init.d/" + service_name;
        commands = ["chmod +x " + destination, "mkdir -p /var/lock/subsys", "touch /var/lock/subsys/" + service_name, "chkconfig --add " + service_name, "chkconfig " + service_name + " on", "initctl list"];
        break;

      case "macos":
      case "darwin":
      case "launchd":
        template = getTemplate("launchd");
        destination = _path["default"].join(process.env.HOME, "Library/LaunchAgents/" + launchd_service_name + ".plist");
        commands = ["launchctl load -w " + destination];
        break;

      case "freebsd":
      case "rcd":
        template = getTemplate("rcd");
        service_name = opts.serviceName || "pm2_" + user;
        destination = "/usr/local/etc/rc.d/" + service_name;
        commands = ["chmod 755 " + destination, "sysrc " + service_name + "_enable=YES"];
        break;

      case "openbsd":
      case "rcd-openbsd":
        template = getTemplate("rcd-openbsd");
        service_name = opts.serviceName || "pm2_" + user;
        destination = _path["default"].join("/etc/rc.d/", service_name);
        commands = ["chmod 755 " + destination, "rcctl enable " + service_name, "rcctl start " + service_name];
        break;

      case "openrc":
        template = getTemplate("openrc");
        service_name = openrc_service_name;
        destination = "/etc/init.d/" + service_name;
        commands = ["chmod +x " + destination, "rc-update add " + service_name + " default"];
        break;

      case "smf":
      case "sunos":
      case "solaris":
        template = getTemplate("smf");
        service_name = opts.serviceName || "pm2_" + user;
        destination = _path["default"].join((0, _os.tmpdir)(), service_name + ".xml");
        commands = ["svccfg import " + destination, "svcadm enable " + service_name];
        break;

      default:
        throw new Error("Unknown platform / init system name");
    }
    /**
     * 4# Replace template variable value
     */


    var envPath;

    if (_constants["default"].HAS_NODE_EMBEDDED == true) {
      envPath = _util["default"].format("%s:%s", process.env.PATH || "", _path["default"].dirname(process.execPath));
    } else if (new RegExp(_path["default"].dirname(process.execPath)).test(process.env.PATH)) {
      envPath = process.env.PATH;
    } else {
      envPath = _util["default"].format("%s:%s", process.env.PATH || "", _path["default"].dirname(process.execPath));
    }

    template = template.replace(/%PM2_PATH%/g, process.mainModule.filename).replace(/%NODE_PATH%/g, envPath).replace(/%USER%/g, user).replace(/%HOME_PATH%/g, opts.hp ? _path["default"].resolve(opts.hp, ".pm2") : _constants["default"].PM2_ROOT_PATH).replace(/%SERVICE_NAME%/g, service_name);

    _Common["default"].printOut(_chalk["default"].bold("Platform"), platform);

    _Common["default"].printOut(_chalk["default"].bold("Template"));

    _Common["default"].printOut(template);

    _Common["default"].printOut(_chalk["default"].bold("Target path"));

    _Common["default"].printOut(destination);

    _Common["default"].printOut(_chalk["default"].bold("Command list"));

    _Common["default"].printOut(commands);

    _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Writing init configuration in " + destination);

    try {
      _fs["default"].writeFileSync(destination, template);
    } catch (e) {
      // console.error(cst.PREFIX_MSG_ERR + "Failure when trying to write startup script");
      console.error(new Error(_constants["default"].PREFIX_MSG_ERR + "Failure when trying to write startup script").stack);
      console.error(e.message || e);
      return cb(e);
    }

    _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Making script booting at startup...");

    (0, _forEachLimit["default"])(commands, 1, function (command, next) {
      _Common["default"].printOut(_constants["default"].PREFIX_MSG + "[-] Executing: %s...", _chalk["default"].bold(command));

      (0, _sexec["default"])(command, function (code, stdout, stderr) {
        if (code === 0) {
          _Common["default"].printOut(_constants["default"].PREFIX_MSG + _chalk["default"].bold("[v] Command successfully executed."));

          return next();
        } else {
          _Common["default"].printOut(_chalk["default"].red("[ERROR] Exit code : " + code));

          return next(new Error(command + " failed, see error above."));
        }
      });
    }, function (err) {
      if (err) {
        // console.error(cst.PREFIX_MSG_ERR + (err.message || err));
        console.error(_constants["default"].PREFIX_MSG_ERR + (err.stack || err));
        return cb(err);
      }

      _Common["default"].printOut(_chalk["default"].bold.blue("+---------------------------------------+"));

      _Common["default"].printOut(_chalk["default"].bold.blue(_constants["default"].PREFIX_MSG + "Freeze a process list on reboot via:"));

      _Common["default"].printOut(_chalk["default"].bold("$ pm2 save"));

      _Common["default"].printOut("");

      _Common["default"].printOut(_chalk["default"].bold.blue(_constants["default"].PREFIX_MSG + "Remove init script via:"));

      _Common["default"].printOut(_chalk["default"].bold("$ pm2 unstartup " + platform));

      return cb(null, {
        destination: destination,
        template: template
      });
    });
  });
  (0, _defineProperty2["default"])(this, "autodump", function (cb) {
    return cb();
  });
  (0, _defineProperty2["default"])(this, "dump", function (force, cb) {
    var env_arr = [];

    if (typeof force === "function") {
      cb = force;
      force = false;
    }

    if (!cb) {
      _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Saving current process list...");
    }

    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        _Common["default"].printError("Error retrieving process list: " + err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }
      /**
      * Description
      * @method fin
      * @param {} err
      * @return
      */


      var fin = function fin(err) {
        // try to fix issues with empty dump file
        // like #3485
        if (!force && env_arr.length === 0 && !process.env.FORCE) {
          // fix : if no dump file, no process, only module and after pm2 update
          if (!_fs["default"].existsSync(_constants["default"].DUMP_FILE_PATH)) {
            _this.clearDump(function () {});
          } // if no process in list don't modify dump file
          // process list should not be empty


          if (cb) {
            return cb(new Error("Process list empty, cannot save empty list"));
          } else {
            _Common["default"].printOut(_constants["default"].PREFIX_MSG_WARNING + "PM2 is not managing any process, skipping save...");

            _Common["default"].printOut(_constants["default"].PREFIX_MSG_WARNING + "To force saving use: pm2 save --force");

            _this.exitCli(_constants["default"].SUCCESS_EXIT);

            return;
          }
        } // Back up dump file


        try {
          if (_fs["default"].existsSync(_constants["default"].DUMP_FILE_PATH)) {
            _fs["default"].writeFileSync(_constants["default"].DUMP_BACKUP_FILE_PATH, _fs["default"].readFileSync(_constants["default"].DUMP_FILE_PATH));
          }
        } catch (e) {
          console.error(e.stack || e); // Common.printOut(cst.PREFIX_MSG_ERR + "Failed to back up dump file in %s", cst.DUMP_BACKUP_FILE_PATH);

          _Common["default"].printOut(new Error(_constants["default"].PREFIX_MSG_ERR + "Failed to back up dump file in %s" + _constants["default"].DUMP_BACKUP_FILE_PATH).stack);
        } // Overwrite dump file, delete if broken and exit


        try {
          _fs["default"].writeFileSync(_constants["default"].DUMP_FILE_PATH, JSON.stringify(env_arr, [""], 2));
        } catch (e) {
          console.error(e.stack || e);

          try {
            // try to backup file
            if (_fs["default"].existsSync(_constants["default"].DUMP_BACKUP_FILE_PATH)) {
              _fs["default"].writeFileSync(_constants["default"].DUMP_FILE_PATH, _fs["default"].readFileSync(_constants["default"].DUMP_BACKUP_FILE_PATH));
            }
          } catch (e) {
            // don't keep broken file
            _fs["default"].unlinkSync(_constants["default"].DUMP_FILE_PATH);

            console.error(e.stack || e);
          } // Common.printOut(cst.PREFIX_MSG_ERR + "Failed to save dump file in %s", cst.DUMP_FILE_PATH);


          _Common["default"].printOut(new Error(_constants["default"].PREFIX_MSG_ERR + "Failed to save dump file in %s" + _constants["default"].DUMP_FILE_PATH).stack);

          return _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        if (cb) {
          return cb(null, {
            success: true
          });
        }

        _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Successfully saved in %s", _constants["default"].DUMP_FILE_PATH);

        return _this.exitCli(_constants["default"].SUCCESS_EXIT);
      };

      (function ex(apps) {
        if (!apps[0]) {
          return fin(null);
        }

        delete apps[0].pm2_env.instances;
        delete apps[0].pm2_env.pm_id;
        delete apps[0].pm2_env.prev_restart_delay;

        if (!apps[0].pm2_env.pmx_module) {
          env_arr.push(apps[0].pm2_env);
        }

        apps.shift();
        return ex(apps);
      })(list);
    });
  });
  (0, _defineProperty2["default"])(this, "clearDump", function (cb) {
    _fs["default"].writeFileSync(_constants["default"].DUMP_FILE_PATH, JSON.stringify([]));

    if (cb && typeof cb === "function") {
      return cb();
    }

    _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Successfully created %s", _constants["default"].DUMP_FILE_PATH);

    return _this.exitCli(_constants["default"].SUCCESS_EXIT);
  });
  (0, _defineProperty2["default"])(this, "resurrect", function (cb) {
    var apps = {};
    var processes;

    function readDumpFile(dumpFilePath) {
      _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Restoring processes located in %s", dumpFilePath);

      var apps;

      try {
        apps = _fs["default"].readFileSync(dumpFilePath);
      } catch (e) {
        // Common.printError(cst.PREFIX_MSG_ERR + "Failed to read dump file in %s", dumpFilePath);
        _Common["default"].printError(new Error(_constants["default"].PREFIX_MSG_ERR + "Failed to read dump file in %s" + dumpFilePath).stack);

        throw e;
      }

      return apps;
    }

    function parseDumpFile(dumpFilePath, apps) {
      var processes;

      try {
        processes = _Common["default"].parseConfig(apps, "none");
      } catch (e) {
        // Common.printError(cst.PREFIX_MSG_ERR + "Failed to parse dump file in %s", dumpFilePath);
        _Common["default"].printError(new Error(_constants["default"].PREFIX_MSG_ERR + "Failed to parse dump file in %s" + dumpFilePath).stack);

        try {
          _fs["default"].unlinkSync(dumpFilePath);
        } catch (e) {
          console.error(e.stack || e);
        }

        throw e;
      }

      return processes;
    } // Read dump file, fall back to backup, delete if broken


    try {
      apps = readDumpFile(_constants["default"].DUMP_FILE_PATH);
      processes = parseDumpFile(_constants["default"].DUMP_FILE_PATH, apps);
    } catch (e) {
      try {
        apps = readDumpFile(_constants["default"].DUMP_BACKUP_FILE_PATH);
        processes = parseDumpFile(_constants["default"].DUMP_BACKUP_FILE_PATH, apps);
      } catch (e) {
        // Common.printError(cst.PREFIX_MSG_ERR + "No processes saved; DUMP file doesn't exist");
        _Common["default"].printError(new Error(_constants["default"].PREFIX_MSG_ERR + "No processes saved; DUMP file doesn't exist").stack); // if (cb) return cb(Common.retErr(e));
        // else return that.exitCli(cst.ERROR_EXIT);


        return _this.speedList();
      }
    }

    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        _Common["default"].printError(err);

        return _this.exitCli(1);
      }

      var current = [];
      var target = [];
      list.forEach(function (app) {
        if (!current[app.name]) {
          current[app.name] = 0;
        }

        current[app.name]++;
      });
      processes.forEach(function (app) {
        if (!target[app.name]) {
          target[app.name] = 0;
        }

        target[app.name]++;
      });
      var tostart = Object.keys(target).filter(function (i) {
        return Object.keys(current).indexOf(i) < 0;
      });
      (0, _eachLimit["default"])(processes, _constants["default"].CONCURRENT_ACTIONS, function (app, next) {
        if (tostart.indexOf(app.name) == -1) {
          return next();
        }

        _this.Client.executeRemote("prepare", app, function (err, dt) {
          if (err) {
            _Common["default"].printError(err);
          } else {
            _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Process %s restored", app.pm_exec_path);
          }

          next();
        });
      }, function (err) {
        return cb ? cb(null, apps) : _this.speedList();
      });
    });
  });
  (0, _defineProperty2["default"])(this, "flush", function (api, cb) {
    if (!api) {
      _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Flushing " + _constants["default"].PM2_LOG_FILE_PATH);

      _fs["default"].closeSync(_fs["default"].openSync(_constants["default"].PM2_LOG_FILE_PATH, "w"));
    }

    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      list.forEach(function (l) {
        if (typeof api == "undefined") {
          _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Flushing:");

          _Common["default"].printOut(_constants["default"].PREFIX_MSG + l.pm2_env.pm_out_log_path);

          _Common["default"].printOut(_constants["default"].PREFIX_MSG + l.pm2_env.pm_err_log_path);

          if (l.pm2_env.pm_log_path) {
            _Common["default"].printOut(_constants["default"].PREFIX_MSG + l.pm2_env.pm_log_path);

            _fs["default"].closeSync(_fs["default"].openSync(l.pm2_env.pm_log_path, "w"));
          }

          _fs["default"].closeSync(_fs["default"].openSync(l.pm2_env.pm_out_log_path, "w"));

          _fs["default"].closeSync(_fs["default"].openSync(l.pm2_env.pm_err_log_path, "w"));
        } else if (l.pm2_env.name === api) {
          _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Flushing:");

          _Common["default"].printOut(_constants["default"].PREFIX_MSG + l.pm2_env.pm_out_log_path);

          _Common["default"].printOut(_constants["default"].PREFIX_MSG + l.pm2_env.pm_err_log_path);

          if (l.pm2_env.pm_log_path && l.pm2_env.pm_log_path.lastIndexOf("/") < l.pm2_env.pm_log_path.lastIndexOf(api)) {
            _Common["default"].printOut(_constants["default"].PREFIX_MSG + l.pm2_env.pm_log_path);

            _fs["default"].closeSync(_fs["default"].openSync(l.pm2_env.pm_log_path, "w"));
          }

          if (l.pm2_env.pm_out_log_path.lastIndexOf("/") < l.pm2_env.pm_out_log_path.lastIndexOf(api)) {
            _fs["default"].closeSync(_fs["default"].openSync(l.pm2_env.pm_out_log_path, "w"));
          }

          if (l.pm2_env.pm_err_log_path.lastIndexOf("/") < l.pm2_env.pm_err_log_path.lastIndexOf(api)) {
            _fs["default"].closeSync(_fs["default"].openSync(l.pm2_env.pm_err_log_path, "w"));
          }
        }
      });

      _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Logs flushed");

      return cb ? cb(null, list) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "logrotate", function (opts, cb) {
    if (process.getuid() != 0) {
      return exec("whoami", function (err, stdout, stderr) {
        _Common["default"].printError(_constants["default"].PREFIX_MSG + "You have to run this command as root. Execute the following command:");

        _Common["default"].printError(_constants["default"].PREFIX_MSG + _chalk["default"].grey("      sudo env PATH=$PATH:" + _path["default"].dirname(process.execPath) + " pm2 logrotate -u " + stdout.trim()));

        cb ? cb(_Common["default"].retErr("You have to run this with elevated rights")) : _this.exitCli(_constants["default"].ERROR_EXIT);
      });
    }

    if (!_fs["default"].existsSync("/etc/logrotate.d")) {
      _Common["default"].printError(_constants["default"].PREFIX_MSG + "/etc/logrotate.d does not exist we can not copy the default configuration.");

      return cb ? cb(_Common["default"].retErr("/etc/logrotate.d does not exist")) : _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    var templatePath = _path["default"].join(_constants["default"].TEMPLATE_FOLDER, _constants["default"].LOGROTATE_SCRIPT);

    _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Getting logrorate template " + templatePath);

    var script = _fs["default"].readFileSync(templatePath, {
      encoding: "utf8"
    });

    var user = opts.user || "root";
    script = script.replace(/%HOME_PATH%/g, _constants["default"].PM2_ROOT_PATH).replace(/%USER%/g, user);

    try {
      _fs["default"].writeFileSync("/etc/logrotate.d/pm2-" + user, script);
    } catch (e) {
      console.error(e.stack || e);
    }

    _Common["default"].printOut(_constants["default"].PREFIX_MSG + "Logrotate configuration added to /etc/logrotate.d/pm2");

    return cb ? cb(null, {
      success: true
    }) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
  });
  (0, _defineProperty2["default"])(this, "reloadLogs", function (cb) {
    _Common["default"].printOut("Reloading all logs...");

    _this.Client.executeRemote("reloadLogs", {}, function (err, logs) {
      if (err) {
        _Common["default"].printError(err);

        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      _Common["default"].printOut("All logs reloaded");

      return cb ? cb(null, logs) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "streamLogs", function (id, lines, raw, timestamp, exclusive, highlight) {
    var files_list = []; // If no argument is given, we stream logs for all running apps

    id = id || "all";
    lines = lines !== undefined ? lines : 20;
    lines = lines < 0 ? -lines : lines; // Avoid duplicates and check if path is different from '/dev/null'

    var pushIfUnique = function pushIfUnique(entry) {
      var exists = false;

      if (entry.path.toLowerCase && entry.path.toLowerCase() !== "/dev/null") {
        files_list.some(function (file) {
          if (file.path === entry.path) {
            exists = true;
          }

          return exists;
        });

        if (exists) {
          return;
        }

        files_list.push(entry);
      }
    }; // Get the list of all running apps


    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      var regexList = [];
      var namespaceList = [];

      if (err) {
        _Common["default"].printError(err);

        _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      if (lines === 0) {
        return _Log["default"].stream(_this.Client, id, raw, timestamp, exclusive, highlight);
      }

      _Common["default"].printOut(_chalk["default"].bold.grey(_util["default"].format.call(_this, "[TAILING] Tailing last %d lines for [%s] process%s (change the value with --lines option)", lines, id, id === "all" ? "es" : ""))); // Populate the array `files_list` with the paths of all files we need to tail


      list.forEach(function (proc) {
        if (proc.pm2_env && (id === "all" || proc.pm2_env.name == id || proc.pm2_env.pm_id == id)) {
          if (proc.pm2_env.pm_out_log_path && exclusive !== "err") {
            pushIfUnique({
              path: proc.pm2_env.pm_out_log_path,
              app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
              type: "out"
            });
          }

          if (proc.pm2_env.pm_err_log_path && exclusive !== "out") {
            pushIfUnique({
              path: proc.pm2_env.pm_err_log_path,
              app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
              type: "err"
            });
          }
        } else if (proc.pm2_env && proc.pm2_env.namespace == id) {
          if (namespaceList.indexOf(proc.pm2_env.name) === -1) {
            namespaceList.push(proc.pm2_env.name);
          }

          if (proc.pm2_env.pm_out_log_path && exclusive !== "err") {
            pushIfUnique({
              path: proc.pm2_env.pm_out_log_path,
              app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
              type: "out"
            });
          }

          if (proc.pm2_env.pm_err_log_path && exclusive !== "out") {
            pushIfUnique({
              path: proc.pm2_env.pm_err_log_path,
              app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
              type: "err"
            });
          }
        } else if (proc.pm2_env && isNaN(id) && id[0] === "/" && id[id.length - 1] === "/") {
          // Populate the array `files_list` with the paths of all files we need to tail, when log in put is a regex
          var regex = new RegExp(id.replace(/\//g, ""));

          if (regex.test(proc.pm2_env.name)) {
            if (regexList.indexOf(proc.pm2_env.name) === -1) {
              regexList.push(proc.pm2_env.name);
            }

            if (proc.pm2_env.pm_out_log_path && exclusive !== "err") {
              pushIfUnique({
                path: proc.pm2_env.pm_out_log_path,
                app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
                type: "out"
              });
            }

            if (proc.pm2_env.pm_err_log_path && exclusive !== "out") {
              pushIfUnique({
                path: proc.pm2_env.pm_err_log_path,
                app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
                type: "err"
              });
            }
          }
        }
      }); //for fixing issue https://github.com/Unitech/pm2/issues/3506

      /* if (files_list && files_list.length == 0) {
      Common.printError(cst.PREFIX_MSG_ERR + 'No file to stream for app [%s], exiting.', id);
      return process.exit(cst.ERROR_EXIT);
      }*/

      if (!raw && (id === "all" || id === "PM2") && exclusive === false) {
        _Log["default"].tail([{
          path: _constants["default"].PM2_LOG_FILE_PATH,
          app_name: "PM2",
          type: "PM2"
        }], lines, raw, function () {
          _Log["default"].tail(files_list, lines, raw, function () {
            _Log["default"].stream(_this.Client, id, raw, timestamp, exclusive, highlight);
          });
        });
      } else {
        _Log["default"].tail(files_list, lines, raw, function () {
          if (regexList.length > 0) {
            regexList.forEach(function (id) {
              _Log["default"].stream(_this.Client, id, raw, timestamp, exclusive, highlight);
            });
          } else if (namespaceList.length > 0) {
            namespaceList.forEach(function (id) {
              _Log["default"].stream(_this.Client, id, raw, timestamp, exclusive, highlight);
            });
          } else {
            _Log["default"].stream(_this.Client, id, raw, timestamp, exclusive, highlight);
          }
        });
      }
    });
  });
  (0, _defineProperty2["default"])(this, "printLogs", function (id, lines, raw, timestamp, exclusive) {
    var files_list = []; // If no argument is given, we stream logs for all running apps

    id = id || "all";
    lines = lines !== undefined ? lines : 20;
    lines = lines < 0 ? -lines : lines; // Avoid duplicates and check if path is different from '/dev/null'

    var pushIfUnique = function pushIfUnique(entry) {
      var exists = false;

      if (entry.path.toLowerCase && entry.path.toLowerCase() !== "/dev/null") {
        files_list.some(function (file) {
          if (file.path === entry.path) {
            exists = true;
          }

          return exists;
        });

        if (exists) {
          return;
        }

        files_list.push(entry);
      }
    }; // Get the list of all running apps


    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        _Common["default"].printError(err);

        _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      if (lines <= 0) {
        return _this.exitCli(_constants["default"].SUCCESS_EXIT);
      }

      _Common["default"].printOut(_chalk["default"].bold.grey(_util["default"].format.call(_this, "[TAILING] Tailing last %d lines for [%s] process%s (change the value with --lines option)", lines, id, id === "all" ? "es" : ""))); // Populate the array `files_list` with the paths of all files we need to tail


      list.forEach(function (proc) {
        if (proc.pm2_env && (id === "all" || proc.pm2_env.name == id || proc.pm2_env.pm_id == id)) {
          if (proc.pm2_env.pm_out_log_path && exclusive !== "err") {
            pushIfUnique({
              path: proc.pm2_env.pm_out_log_path,
              app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
              type: "out"
            });
          }

          if (proc.pm2_env.pm_err_log_path && exclusive !== "out") {
            pushIfUnique({
              path: proc.pm2_env.pm_err_log_path,
              app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
              type: "err"
            });
          }
        } else if (proc.pm2_env && isNaN(id) && id[0] === "/" && id[id.length - 1] === "/") {
          // Populate the array `files_list` with the paths of all files we need to tail, when log in put is a regex
          var regex = new RegExp(id.replace(/\//g, ""));

          if (regex.test(proc.pm2_env.name)) {
            if (proc.pm2_env.pm_out_log_path && exclusive !== "err") {
              pushIfUnique({
                path: proc.pm2_env.pm_out_log_path,
                app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
                type: "out"
              });
            }

            if (proc.pm2_env.pm_err_log_path && exclusive !== "out") {
              pushIfUnique({
                path: proc.pm2_env.pm_err_log_path,
                app_name: proc.pm2_env.pm_id + "|" + proc.pm2_env.name,
                type: "err"
              });
            }
          }
        }
      });

      if (!raw && (id === "all" || id === "PM2") && exclusive === false) {
        _Log["default"].tail([{
          path: _constants["default"].PM2_LOG_FILE_PATH,
          app_name: "PM2",
          type: "PM2"
        }], lines, raw, function () {
          _Log["default"].tail(files_list, lines, raw, function () {
            this.exitCli(_constants["default"].SUCCESS_EXIT);
          });
        });
      } else {
        _Log["default"].tail(files_list, lines, raw, function () {
          this.exitCli(_constants["default"].SUCCESS_EXIT);
        });
      }
    });
  });
  (0, _defineProperty2["default"])(this, "generateDockerfile", function (script, opts) {
    var docker_filepath = _path["default"].join(process.cwd(), "Dockerfile");

    _fs["default"].stat(docker_filepath, function (err, stat) {
      if (err || opts.force == true) {
        generateDockerfile(docker_filepath, script, {
          mode: "development"
        }).then(function () {
          console.log(_chalk["default"].bold("New Dockerfile generated in current folder"));
          console.log(_chalk["default"].bold("You can now run\n$ pm2 docker:dev <file|config>"));
          return _this.exitCli(_constants["default"].SUCCESS_EXIT);
        });
        return false;
      }

      console.log(_chalk["default"].red.bold("Dockerfile already exists in this folder, use --force if you want to replace it"));

      _this.exitCli(_constants["default"].ERROR_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "dockerMode", function (script, opts, mode) {
    var promptly = require("promptly");

    handleExit(_this, opts, mode);

    if (mode == "distribution" && !opts.imageName) {
      console.error(_chalk["default"].bold.red("--image-name [name] option is missing"));
      return _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    var template;
    var app_path, main_script;
    var node_version = opts.nodeVersion ? opts.nodeVersion.split(".")[0] : "latest";

    var image_name = opts.imageName || require("crypto").randomBytes(6).toString("hex");

    if (script.indexOf("/") > -1) {
      app_path = _path["default"].join(process.cwd(), _path["default"].dirname(script));
      main_script = _path["default"].basename(script);
    } else {
      app_path = process.cwd();
      main_script = script;
    }

    checkDockerSetup().then(function () {
      /////////////////////////
      // Generate Dockerfile //
      /////////////////////////
      return new Promise(function (resolve, reject) {
        var docker_filepath = _path["default"].join(process.cwd(), "Dockerfile");

        _fs["default"].stat(docker_filepath, function (err, stat) {
          if (err) {
            // Dockerfile does not exist, generate one
            // console.log(chalk.blue.bold('Generating new Dockerfile'));
            if (opts.force == true) {
              return resolve(generateDockerfile(docker_filepath, main_script, {
                node_version: node_version,
                mode: mode
              }));
            }

            if (opts.dockerdaemon) {
              return resolve(generateDockerfile(docker_filepath, main_script, {
                node_version: node_version,
                mode: mode
              }));
            }

            promptly.prompt("No Dockerfile in current directory, ok to generate a new one? (y/n)", function (err, value) {
              if (value == "y") {
                return resolve(generateDockerfile(docker_filepath, main_script, {
                  node_version: node_version,
                  mode: mode
                }));
              } else {
                return _this.exitCli(_constants["default"].SUCCESS_EXIT);
              }
            });
            return false;
          }

          return resolve(switchDockerFile(docker_filepath, main_script, {
            node_version: node_version,
            mode: mode
          }));
        });
      });
    }).then(function (_template) {
      template = _template;
      return Promise.resolve();
    }).then(function () {
      //////////////////
      // Docker build //
      //////////////////
      var docker_build = _util["default"].format("docker build -t %s -f %s", image_name, template.Dockerfile_path);

      if (opts.fresh == true) {
        docker_build += " --no-cache";
      }

      docker_build += " .";
      console.log();
      fmt.sep();
      fmt.title("Building Boot System");
      fmt.field("Type", _chalk["default"].cyan.bold("Docker"));
      fmt.field("Mode", mode);
      fmt.field("Image name", image_name);
      fmt.field("Docker build command", docker_build);
      fmt.field("Dockerfile path", template.Dockerfile_path);
      fmt.sep();
      return pspawn(docker_build);
    }).then(function () {
      ////////////////
      // Docker run //
      ////////////////
      var docker_run = "docker run --net host";

      if (opts.dockerdaemon == true) {
        docker_run += " -d";
      }

      if (mode != "distribution") {
        docker_run += _util["default"].format(" -v %s:/var/app -v /var/app/node_modules", app_path);
      }

      docker_run += " " + image_name;
      var dockerfile_parsed = template.Dockerfile.split("\n");
      var base_image = dockerfile_parsed[0];
      var run_cmd = dockerfile_parsed[dockerfile_parsed.length - 1];
      console.log();
      fmt.sep();
      fmt.title("Booting");
      fmt.field("Type", _chalk["default"].cyan.bold("Docker"));
      fmt.field("Mode", mode);
      fmt.field("Base Image", base_image);
      fmt.field("Image Name", image_name);
      fmt.field("Docker Command", docker_run);
      fmt.field("RUN Command", run_cmd);
      fmt.field("CWD", app_path);
      fmt.sep();
      return pspawn(docker_run);
    }).then(function () {
      console.log(_chalk["default"].blue.bold(">>> Leaving Docker instance uuid=%s"), image_name);

      _this.disconnect();

      return Promise.resolve();
    })["catch"](function (err) {
      console.log();
      console.log(_chalk["default"].grey("Raw error=", err.message));

      _this.disconnect();
    });
  });
  (0, _defineProperty2["default"])(this, "linkManagement", function (cmd, public_key, machine, opts, cb) {
    // pm2 link stop || kill
    if (cmd == "stop" || cmd == "kill") {
      _this.gl_is_km_linked = false;
      console.log(_constants["default"].PM2_IO_MSG + " Stopping agent...");
      return _this.killAgent(function (err) {
        if (err) {
          _Common["default"].printError(err);

          return process.exit(_constants["default"].ERROR_EXIT);
        }

        console.log(_constants["default"].PM2_IO_MSG + " Stopped");

        _this.reload("all", function () {
          return process.exit(_constants["default"].SUCCESS_EXIT);
        });
      });
    } // pm2 link info


    if (cmd == "info") {
      console.log(_constants["default"].PM2_IO_MSG + " Getting agent information...");

      _this.agentInfos(function (err, infos) {
        if (err) {
          console.error(_constants["default"].PM2_IO_MSG_ERR + " " + err.message);
          return _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        console.log(infos);
        return _this.exitCli(_constants["default"].SUCCESS_EXIT);
      });

      return false;
    } // pm2 link delete


    if (cmd == "delete") {
      _this.gl_is_km_linked = false;
      console.log(_constants["default"].PM2_IO_MSG + " Permanently disable agent...");

      _this.killAgent(function (err) {
        try {
          _fs["default"].unlinkSync(_constants["default"].INTERACTION_CONF);
        } catch (e) {
          console.log(_constants["default"].PM2_IO_MSG + " No interaction config file found");
          return process.exit(_constants["default"].SUCCESS_EXIT);
        }

        console.log(_constants["default"].PM2_IO_MSG + " Agent interaction ended");

        if (!cb) {
          return process.exit(_constants["default"].SUCCESS_EXIT);
        }

        return cb();
      });

      return false;
    }

    if (cmd && !public_key) {
      console.error(_constants["default"].PM2_IO_MSG + " Command [%s] unknown or missing public key", cmd);
      return process.exit(_constants["default"].ERROR_EXIT);
    } // pm2 link xxx yyy


    var infos;

    if (!cmd) {
      infos = null;
    } else {
      infos = {
        public_key: public_key,
        secret_key: cmd,
        machine_name: machine,
        info_node: opts.infoNode || null,
        pm2_version: _package["default"].version
      };
    }

    if (opts && opts.axon === true && infos) {
      infos.agent_transport_axon = true;
      infos.agent_transport_websocket = false;
      process.env.AGENT_TRANSPORT_AXON = "true";
      process.env.AGENT_TRANSPORT_WEBSOCKET = "false";
    } else if (infos) {
      infos.agent_transport_axon = false;
      infos.agent_transport_websocket = true;
      process.env.AGENT_TRANSPORT_AXON = "false";
      process.env.AGENT_TRANSPORT_WEBSOCKET = "true";
    }

    _this.link(infos, cb);
  });
  (0, _defineProperty2["default"])(this, "link", function (infos, cb) {
    if (infos && !infos.machine_name) {
      infos.machine_name = require("os").hostname() + "-" + require("crypto").randomBytes(2).toString("hex");
    }

    _pm2tIoAgent["default"].launchAndInteract(_constants["default"], infos, function (err, dt) {
      if (err) {
        _Common["default"].printError(_constants["default"].PM2_IO_MSG + " Run `$ pm2 plus` to connect");

        return _this.exitCli(_constants["default"].ERROR_EXIT);
      }

      console.log(_chalk["default"].bold.green("[+] PM2+ activated!"));

      if (!cb) {
        return _this.exitCli(_constants["default"].SUCCESS_EXIT);
      }

      return cb(null, dt);
    });
  });
  (0, _defineProperty2["default"])(this, "agentInfos", function (cb) {
    _pm2tIoAgent["default"].getInteractInfo(_this._conf, function (err, data) {
      if (err) {
        return cb(_Common["default"].retErr(err));
      }

      return cb(null, data);
    });
  });
  (0, _defineProperty2["default"])(this, "killAgent", function (cb) {
    _pm2tIoAgent["default"].killInteractorDaemon(_this._conf, function (err) {
      if (err) {
        return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
      }

      return cb ? cb(null) : _this.exitCli(_constants["default"].SUCCESS_EXIT);
    });
  });
  (0, _defineProperty2["default"])(this, "unlink", function (cb) {
    _this.linkManagement("delete", cb);
  });
  (0, _defineProperty2["default"])(this, "monitorState", function (state, target, cb) {
    if (!target) {
      // Common.printError(cst.PREFIX_MSG_ERR + "Please specify an <app_name|pm_id>");
      _Common["default"].printError(new Error(_constants["default"].PREFIX_MSG_ERR + "Please specify an <app_name|pm_id>").stack);

      return cb ? cb(new Error("argument missing")) : _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    var monitor = function monitor(pm_id, cb) {
      // State can be monitor or unmonitor
      _this.Client.executeRemote(state, pm_id, cb);
    };

    if (target === "all") {
      _this.Client.getAllProcessId(function (err, procs) {
        if (err) {
          _Common["default"].printError(err);

          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        (0, _forEachLimit["default"])(procs, 1, monitor, function (err, res) {
          return typeof cb === "function" ? cb(err, res) : _this.speedList();
        });
      });
    } else if (!Number.isInteger(parseInt(target))) {
      _this.Client.getProcessIdByName(target, true, function (err, procs) {
        if (err) {
          _Common["default"].printError(err);

          return cb ? cb(_Common["default"].retErr(err)) : _this.exitCli(_constants["default"].ERROR_EXIT);
        }

        (0, _forEachLimit["default"])(procs, 1, monitor, function (err, res) {
          return typeof cb === "function" ? cb(err, res) : _this.speedList();
        });
      });
    } else {
      monitor(parseInt(target), function (err, res) {
        return typeof cb === "function" ? cb(err, res) : _this.speedList();
      });
    }
  });
  (0, _defineProperty2["default"])(this, "openDashboard", function () {
    if (!_this.gl_interact_infos) {
      _Common["default"].printError(_chalk["default"].bold.white("Agent if offline, type `$ pm2 plus` to log in"));

      return _this.exitCli(_constants["default"].ERROR_EXIT);
    }

    var uri = "https://app.pm2.io/#/r/".concat(_this.gl_interact_infos.public_key);
    console.log(_constants["default"].PM2_IO_MSG + " Opening ".concat(uri));
    (0, _open["default"])(uri);
    setTimeout(function (_) {
      _this.exitCli();
    }, 200);
  });
  (0, _defineProperty2["default"])(this, "clearSetup", function (opts, cb) {
    var modules = ["event-loop-inspector"];
    _this.gl_is_km_linked = false;

    if (_semver["default"].satisfies(process.version, "< 10.0.0")) {
      modules.push("v8-profiler-node8");
    }

    (0, _forEach["default"])(modules, function (_module, next) {
      // this.uninstall(this, _module, () => {
      _this.uninstall(_module, function () {
        next();
      });
    }, function (err) {
      _this.reload("all", function () {
        return cb();
      });
    });
  });
  (0, _defineProperty2["default"])(this, "minimumSetup", function (opts, cb) {
    _this.gl_is_km_linked = true;

    var install = function install(cb) {
      var modules = [];

      if (opts.type === "enterprise" || opts.type === "plus") {
        modules = ["pm2-logrotate", "pm2-server-monit"];

        if (_semver["default"].satisfies(process.version, "< 8.0.0")) {
          modules.push("v8-profiler-node8");
        }

        if (opts.type === "enterprise") {
          modules.push("deep-metrics");
        }
      }

      (0, _forEach["default"])(modules, function (_module, next) {
        // this.install(this, _module, {}, () => {
        _this.install(_module, {}, function () {
          next();
        });
      }, function (err) {
        _this.reload("all", function () {
          return cb();
        });
      });
    };

    _this.processesAreAlreadyMonitored(function (already_monitored) {
      if (already_monitored) {
        console.log(_constants["default"].PM2_IO_MSG + " PM2 ".concat(opts.type || "", " bundle already installed"));
        return cb();
      }

      if (opts.installAll) {
        return install(cb);
      } // promptly.confirm(chalk.bold('Install all pm2 plus dependencies ? (y/n)'), (err, answer) => {
      //   if (!err && answer === true)


      return install(cb); // self.reload('all', () => {
      //     return cb()
      //   })
      // });
    });
  });
  (0, _defineProperty2["default"])(this, "processesAreAlreadyMonitored", function (cb) {
    _this.Client.executeRemote("getMonitorData", {}, function (err, list) {
      if (err) {
        return cb(false);
      }

      var l = list.filter(function (l) {
        return l.pm2_env.km_link == true;
      });
      var l2 = list.filter(function (l) {
        return l.name == "pm2-server-monit";
      }); // return cb(l.length > 0 && l2.length > 0 ? true : false)

      cb(l.length > 0 && l2.length > 0 ? true : false);
    });
  });

  if (!_opts) {
    _opts = {};
  }

  this.daemon_mode = typeof _opts.daemon_mode == "undefined" ? true : _opts.daemon_mode;
  this.pm2_home = conf.PM2_ROOT_PATH;
  this.public_key = conf.PUBLIC_KEY || _opts.public_key || null;
  this.secret_key = conf.SECRET_KEY || _opts.secret_key || null;
  this.machine_name = conf.MACHINE_NAME || _opts.machine_name || null;
  /**
   * CWD resolution
   */

  this.cwd = process.cwd();

  if (_opts.cwd) {
    this.cwd = _path["default"].resolve(_opts.cwd);
  }
  /**
   * PM2 HOME resolution
   */


  if (_opts.pm2_home && _opts.independent == true) {
    throw new Error("You cannot set a pm2_home and independent instance in same time");
  }

  if (_opts.pm2_home) {
    // Override default conf file
    this.pm2_home = _opts.pm2_home;
    conf = Object.assign({}, conf, (0, _paths["default"])(this.pm2_home));
  } else if (_opts.independent == true && conf.IS_WINDOWS === false) {
    // Create an unique pm2 instance
    var random_file = _crypto["default"].randomBytes(8).toString("hex");

    this.pm2_home = _path["default"].join("/tmp", random_file); // If we dont explicitly tell to have a daemon
    // It will go as in proc

    if (typeof _opts.daemon_mode == "undefined") {
      this.daemon_mode = false;
    }

    conf = Object.assign({}, conf, (0, _paths["default"])(this.pm2_home));
  }

  this._conf = conf;

  if (conf.IS_WINDOWS) {// Weird fix, may need to be dropped
    // @todo windows connoisseur double check
    // TODO: please check this
    // if (process.stdout._handle && process.stdout._handle.setBlocking)
    //   process.stdout._handle.setBlocking(true);
  }

  this.Client = new _Client["default"]({
    pm2_home: this.pm2_home,
    conf: this._conf,
    secret_key: this.secret_key,
    public_key: this.public_key,
    daemon_mode: this.daemon_mode,
    machine_name: this.machine_name
  });
  this.pm2_configuration = _Configuration["default"].getSync("pm2") || {};
  this.gl_interact_infos = null;
  this.gl_is_km_linked = false;

  try {
    var pid = _fs["default"].readFileSync(conf.INTERACTOR_PID_PATH);

    pid = parseInt(pid.toString().trim());
    process.kill(pid, 0);
    this.gl_is_km_linked = true;
  } catch (e) {
    this.gl_is_km_linked = false;
  } // For testing purposes


  if (this.secret_key && process.env.NODE_ENV == "local_test") {
    this.gl_is_km_linked = true;
  }

  _pm2tIoAgent["default"].ping(this._conf, function (err, result) {
    if (!err && result === true) {
      _fs["default"].readFile(conf.INTERACTION_CONF, function (err, _conf) {
        if (!err) {
          try {
            _this.gl_interact_infos = JSON.parse(_conf.toString());
          } catch (e) {
            try {
              _this.gl_interact_infos = _json["default"].parse(_conf.toString());
            } catch (e) {
              console.error(e);
              _this.gl_interact_infos = null;
            }
          }
        }
      });
    }
  });

  this.gl_retry = 0;
}
/**
 * Connect to PM2
 * Calling this command is now optional
 *
 * @param {Function} cb callback once pm2 is ready for commands
 */

/**
 * From pm2-plus helpers - End
 */
; //////////////////////////
// Load all API methods //
//////////////////////////


var _default = API;
exports["default"] = _default;