"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _strategy = _interopRequireDefault(require("@pm2/js-api/src/auth_strategies/strategy"));

var _querystring = _interopRequireDefault(require("querystring"));

var _fs = _interopRequireDefault(require("fs"));

var _url = _interopRequireDefault(require("url"));

var _tryEach = _interopRequireDefault(require("async/tryEach"));

var _needle = _interopRequireDefault(require("needle"));

var _chalk = _interopRequireDefault(require("chalk"));

var _promptly = _interopRequireDefault(require("promptly"));

var _constants = _interopRequireDefault(require("../../../constants"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CliStrategy = /*#__PURE__*/function (_AuthStrategy) {
  (0, _inherits2["default"])(CliStrategy, _AuthStrategy);

  var _super = _createSuper(CliStrategy);

  function CliStrategy(opts) {
    var _this;

    (0, _classCallCheck2["default"])(this, CliStrategy);
    _this = _super.call(this);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "authenticated", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "callback", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "km", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "BASE_URI", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "client_id", void 0);
    return _this;
  } // the client will try to call this but we handle this part ourselves


  (0, _createClass2["default"])(CliStrategy, [{
    key: "retrieveTokens",
    value: function retrieveTokens(km, cb) {
      this.authenticated = false;
      this.callback = cb;
      this.km = km;
      this.BASE_URI = "https://id.keymetrics.io";
    } // so the cli know if we need to tell user to login/register

  }, {
    key: "isAuthenticated",
    value: function isAuthenticated() {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        if (_this2.authenticated) {
          return resolve(true);
        }

        var tokensPath = _constants["default"].PM2_IO_ACCESS_TOKEN;

        _fs["default"].readFile(tokensPath, "utf8", function (err, tokens) {
          if (err && err.code === "ENOENT") {
            return resolve(false);
          }

          if (err) {
            return reject(err);
          } // verify that the token is valid


          try {
            tokens = JSON.parse(tokens || "{}");
          } catch (err) {
            _fs["default"].unlinkSync(tokensPath);

            return resolve(false);
          } // if the refresh tokens is here, the user could be automatically authenticated


          return resolve(typeof tokens.refresh_token === "string");
        });
      });
    }
  }, {
    key: "verifyToken",
    value: function verifyToken(refresh) {
      return this.km.auth.retrieveToken({
        client_id: this.client_id,
        refresh_token: refresh
      });
    } // called when we are sure the user asked to be logged in

  }, {
    key: "_retrieveTokens",
    value: function _retrieveTokens(optionalCallback) {
      var _this3 = this;

      // const km = this.km;
      var cb = this.callback;
      (0, _tryEach["default"])([// try to find the token via the environment
      function (next) {
        if (!process.env.PM2_IO_TOKEN) {
          return next(new Error("No token in env"));
        }

        _this3.verifyToken(process.env.PM2_IO_TOKEN).then(function (res) {
          return next(null, res.data);
        })["catch"](next);
      }, // try to find it in the file system
      function (next) {
        _fs["default"].readFile(_constants["default"].PM2_IO_ACCESS_TOKEN, "utf8", function (err, tokens) {
          if (err) {
            return next(err);
          } // verify that the token is valid


          tokens = JSON.parse(tokens || "{}");

          if (new Date(tokens.expire_at) > new Date(new Date().toISOString())) {
            return next(null, tokens);
          }

          _this3.verifyToken(tokens.refresh_token).then(function (res) {
            return next(null, res.data);
          })["catch"](next);
        });
      }, // otherwise make the whole flow
      function (next) {
        return _this3.authenticate(function (err, data) {
          if (err instanceof Error) {
            return next(err);
          } // verify that the token is valid


          _this3.verifyToken(data.refresh_token).then(function (res) {
            return next(null, res.data);
          })["catch"](next);
        });
      }], function (err, result) {
        // if present run the optional callback
        if (typeof optionalCallback === "function") {
          optionalCallback(err, result);
        }

        if (result.refresh_token) {
          _this3.authenticated = true;
          var file = _constants["default"].PM2_IO_ACCESS_TOKEN;

          _fs["default"].writeFile(file, JSON.stringify(result), function () {
            return cb(err, result);
          });
        } else {
          return cb(err, result);
        }
      });
    }
  }, {
    key: "authenticate",
    value: function authenticate(cb) {
      var _this4 = this;

      console.log("".concat(_constants["default"].PM2_IO_MSG, " Using non-browser authentication."));

      _promptly["default"].confirm("".concat(_constants["default"].PM2_IO_MSG, " Do you have a pm2.io account? (y/n)"), function (err, answer) {
        // Either login or register
        return answer === true ? _this4.login(cb) : _this4.register(cb);
      });
    }
  }, {
    key: "login",
    value: function login(cb) {
      var _this5 = this;

      var retry = function retry() {
        _promptly["default"].prompt("".concat(_constants["default"].PM2_IO_MSG, " Your username or email: "), function (err, username) {
          if (err) {
            return retry();
          }

          _promptly["default"].password("".concat(_constants["default"].PM2_IO_MSG, " Your password: "), {
            replace: "*"
          }, function (err, password) {
            if (err) {
              return retry();
            }

            console.log("".concat(_constants["default"].PM2_IO_MSG, " Authenticating ..."));

            _this5._loginUser({
              username: username,
              password: password
            }, function (err, data) {
              if (err) {
                console.error("".concat(_constants["default"].PM2_IO_MSG_ERR, " Failed to authenticate: ").concat(err.message));
                return retry();
              }

              return cb(null, data);
            });
          });
        });
      };

      retry();
    }
  }, {
    key: "register",
    value: function register(cb) {
      var _this6 = this;

      console.log("".concat(_constants["default"].PM2_IO_MSG, " No problem ! We just need few informations to create your account"));

      var retry = function retry() {
        _promptly["default"].prompt("".concat(_constants["default"].PM2_IO_MSG, " Please choose an username :"), {
          validator: _this6._validateUsername,
          retry: true
        }, function (err, username) {
          _promptly["default"].prompt("".concat(_constants["default"].PM2_IO_MSG, " Please choose an email :"), {
            validator: _this6._validateEmail,
            retry: true
          }, function (err, email) {
            _promptly["default"].password("".concat(_constants["default"].PM2_IO_MSG, " Please choose a password :"), {
              replace: "*"
            }, function (err, password) {
              _promptly["default"].confirm("".concat(_constants["default"].PM2_IO_MSG, " Do you accept the terms and privacy policy (https://pm2.io/legals/terms_conditions.pdf) ?  (y/n)"), function (err, answer) {
                if (err) {
                  console.error(_chalk["default"].bold.red(err));
                  return retry();
                } else if (answer === false) {
                  console.error("".concat(_constants["default"].PM2_IO_MSG_ERR, " You must accept the terms and privacy policy to contiue."));
                  return retry();
                }

                _this6._registerUser({
                  email: email,
                  password: password,
                  username: username
                }, function (err, data) {
                  console.log("\n");

                  if (err) {
                    console.error("".concat(_constants["default"].PM2_IO_MSG_ERR, " Unexpect error: ").concat(err.message));
                    console.error("".concat(_constants["default"].PM2_IO_MSG_ERR, " You can also contact us to get help: contact@pm2.io"));
                    return process.exit(1);
                  }

                  return cb(undefined, data);
                });
              });
            });
          });
        });
      };

      retry();
    }
    /**
     * Register function
     * @param opts.username
     * @param opts.password
     * @param opts.email
     */

  }, {
    key: "_registerUser",
    value: function _registerUser(opts, cb) {
      var data = Object.assign(opts, {
        password_confirmation: opts.password,
        accept_terms: true
      });

      _needle["default"].post(this.BASE_URI + "/api/oauth/register", data, {
        json: true,
        headers: {
          "X-Register-Provider": "pm2-register",
          "x-client-id": this.client_id
        }
      }, function (err, res, body) {
        if (err) {
          return cb(err);
        }

        if (body.email && body.email.message) {
          return cb(new Error(body.email.message));
        }

        if (body.username && body.username.message) {
          return cb(new Error(body.username.message));
        }

        if (!body.access_token) {
          return cb(new Error(body.msg));
        }

        return cb(null, {
          refresh_token: body.refresh_token.token,
          access_token: body.access_token.token
        });
      });
    }
  }, {
    key: "_loginUser",
    value: function _loginUser(user_info, cb) {
      var _this7 = this;

      var URL_AUTH = "/api/oauth/authorize?response_type=token&scope=all&client_id=" + this.client_id + "&redirect_uri=http://localhost:43532";

      _needle["default"].get(this.BASE_URI + URL_AUTH, function (err, res) {
        if (err) {
          return cb(err);
        }

        var cookie = res.cookies;

        _needle["default"].post(_this7.BASE_URI + "/api/oauth/login", user_info, {
          cookies: cookie
        }, function (err, resp, body) {
          if (err) {
            return cb(err);
          }

          if (resp.statusCode != 200) {
            return cb("Wrong credentials");
          }

          var location = resp.headers["x-redirect"];

          _needle["default"].get(_this7.BASE_URI + location, {
            cookies: cookie
          }, function (err, res) {
            if (err) {
              return cb(err);
            }

            var refresh_token = _querystring["default"].parse(_url["default"].parse(res.headers.location).query).access_token;

            _needle["default"].post(_this7.BASE_URI + "/api/oauth/token", {
              client_id: _this7.client_id,
              grant_type: "refresh_token",
              refresh_token: refresh_token,
              scope: "all"
            }, function (err, res, body) {
              if (err) {
                return cb(err);
              }

              return cb(null, body);
            });
          });
        });
      });
    }
  }, {
    key: "_validateEmail",
    value: function _validateEmail(email) {
      var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

      if (re.test(email) == false) {
        throw new Error("Not an email");
      }

      return email;
    }
  }, {
    key: "_validateUsername",
    value: function _validateUsername(value) {
      if (value.length < 6) {
        throw new Error("Min length of 6");
      }

      return value;
    }
  }, {
    key: "deleteTokens",
    value: function deleteTokens(km) {
      return new Promise(function (resolve, reject) {
        // revoke the refreshToken
        km.auth.revoke().then(function (res) {
          // remove the token from the filesystem
          var file = _constants["default"].PM2_IO_ACCESS_TOKEN;

          _fs["default"].unlinkSync(file);

          return resolve(res);
        })["catch"](reject);
      });
    }
  }]);
  return CliStrategy;
}(_strategy["default"]);

exports["default"] = CliStrategy;