"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _strategy = _interopRequireDefault(require("@pm2/js-api/src/auth_strategies/strategy"));

var _http = _interopRequireDefault(require("http"));

var _fs = _interopRequireDefault(require("fs"));

var _url = _interopRequireDefault(require("url"));

var _child_process = require("child_process");

var _async = _interopRequireDefault(require("async"));

var _constants = _interopRequireDefault(require("../../../constants"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var WebStrategy = /*#__PURE__*/function (_AuthStrategy) {
  (0, _inherits2["default"])(WebStrategy, _AuthStrategy);

  var _super = _createSuper(WebStrategy);

  function WebStrategy(opts) {
    var _this;

    (0, _classCallCheck2["default"])(this, WebStrategy);
    _this = _super.call(this);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "authenticated", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "callback", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "km", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "client_id", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "oauth_endpoint", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "oauth_query", void 0);
    return _this;
  } // the client will try to call this but we handle this part ourselves


  (0, _createClass2["default"])(WebStrategy, [{
    key: "retrieveTokens",
    value: function retrieveTokens(km, cb) {
      this.authenticated = false;
      this.callback = cb;
      this.km = km;
    } // so the cli know if we need to tell user to login/register

  }, {
    key: "isAuthenticated",
    value: function isAuthenticated() {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        if (_this2.authenticated) {
          return resolve(true);
        }

        var tokensPath = _constants["default"].PM2_IO_ACCESS_TOKEN;

        _fs["default"].readFile(tokensPath, function (err, tokens) {
          if (err && err.code === "ENOENT") {
            return resolve(false);
          }

          if (err) {
            return reject(err);
          } // verify that the token is valid


          try {
            tokens = JSON.parse(tokens.toString() || "{}");
          } catch (err) {
            _fs["default"].unlinkSync(tokensPath);

            return resolve(false);
          } // if the refresh tokens is here, the user could be automatically authenticated


          return resolve(typeof tokens.refresh_token === "string");
        });
      });
    } // called when we are sure the user asked to be logged in

  }, {
    key: "_retrieveTokens",
    value: function _retrieveTokens(optionalCallback) {
      var _this3 = this;

      var km = this.km;
      var cb = this.callback;

      var verifyToken = function verifyToken(refresh) {
        return km.auth.retrieveToken({
          client_id: _this3.client_id,
          refresh_token: refresh
        });
      };

      _async["default"].tryEach([// try to find the token via the environment
      function (next) {
        if (!process.env.PM2_IO_TOKEN) {
          return next(new Error("No token in env"));
        }

        verifyToken(process.env.PM2_IO_TOKEN).then(function (res) {
          return next(null, res.data);
        })["catch"](next);
      }, // try to find it in the file system
      function (next) {
        _fs["default"].readFile(_constants["default"].PM2_IO_ACCESS_TOKEN, "utf8", function (err, tokens) {
          if (err) {
            return next(err);
          } // verify that the token is valid


          tokens = JSON.parse(tokens || "{}");

          if (new Date(tokens.expire_at) > new Date(new Date().toISOString())) {
            return next(null, tokens);
          }

          verifyToken(tokens.refresh_token).then(function (res) {
            return next(null, res.data);
          })["catch"](next);
        });
      }, // otherwise make the whole flow
      function (next) {
        return _this3.loginViaWeb(function (data) {
          // verify that the token is valid
          verifyToken(data.access_token).then(function (res) {
            return next(null, res.data);
          })["catch"](function (err) {
            return next(err);
          });
        });
      }], function (err, result) {
        // if present run the optional callback
        if (typeof optionalCallback === "function") {
          optionalCallback(err, result);
        }

        if (result.refresh_token) {
          _this3.authenticated = true;
          var file = _constants["default"].PM2_IO_ACCESS_TOKEN;

          _fs["default"].writeFile(file, JSON.stringify(result), function () {
            return cb(err, result);
          });
        } else {
          return cb(err, result);
        }
      });
    }
  }, {
    key: "loginViaWeb",
    value: function loginViaWeb(cb) {
      var _this4 = this;

      var redirectURL = "".concat(this.oauth_endpoint).concat(this.oauth_query);
      console.log("".concat(_constants["default"].PM2_IO_MSG, " Please follow the popup or go to this URL :"), "\n", "    ", redirectURL);
      var shutdown = false;

      var server = _http["default"].createServer(function (req, res) {
        // only handle one request
        if (shutdown === true) {
          return res.end();
        }

        shutdown = true;

        var query = _url["default"].parse(req.url, true).query;

        res.write("\n        <head>\n          <script>\n          </script>\n        </head>\n        <body>\n          <h2 style=\"text-align: center\">\n            You can go back to your terminal now :)\n          </h2>\n        </body>");
        res.end();
        server.close();
        return cb(query);
      });

      server.listen(43532, function () {
        _this4.open(redirectURL);
      });
    }
  }, {
    key: "deleteTokens",
    value: function deleteTokens(km) {
      return new Promise(function (resolve, reject) {
        // revoke the refreshToken
        km.auth.revoke().then(function (res) {
          // remove the token from the filesystem
          var file = _constants["default"].PM2_IO_ACCESS_TOKEN;

          _fs["default"].unlinkSync(file);

          return resolve(res);
        })["catch"](reject);
      });
    }
  }, {
    key: "open",
    value: function open(target, appName, callback) {
      var opener;

      var escape = function escape(s) {
        return s.replace(/"/g, "\\\"");
      };

      if (typeof appName === "function") {
        callback = appName;
        appName = null;
      }

      switch (process.platform) {
        case "darwin":
          {
            opener = appName ? "open -a \"".concat(escape(appName), "\"") : "open";
            break;
          }

        case "win32":
          {
            opener = appName ? "start \"\" ".concat(escape(appName), "\"") : "start \"\"";
            break;
          }

        default:
          {
            opener = appName ? escape(appName) : "xdg-open";
            break;
          }
      }

      if (process.env.SUDO_USER) {
        opener = "sudo -u " + process.env.SUDO_USER + " " + opener;
      }

      return (0, _child_process.exec)("".concat(opener, " \"").concat(escape(target), "\""), callback);
    }
  }]);
  return WebStrategy;
}(_strategy["default"]);

exports["default"] = WebStrategy;