"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _pm2tIoApm = _interopRequireDefault(require("pm2t-io-apm"));

var _default = {
  injectModules: function injectModules() {
    if (process.env.pmx !== "false") {
      var conf = {};
      var hasSpecificConfig = typeof process.env.io === "string" || process.env.trace === "true"; // pmx is already init, no need to do it twice

      if (hasSpecificConfig === false) {
        return;
      }

      if (process.env.io) {
        var io = JSON.parse(process.env.io);
        conf = io.conf ? io.conf : conf;
      }

      _pm2tIoApm["default"].init(Object.assign({
        tracing: process.env.trace === "true" || false
      }, conf));
    }
  },
  isESModule: function isESModule(exec_path) {
    var fs = require("fs");

    var path = require("path");

    var semver = require("semver");

    var data;

    if (semver.satisfies(process.version, "< 13.3.0")) {
      return false;
    }

    if (path.extname(exec_path) === ".mjs") {
      return true;
    }

    try {
      data = JSON.parse(fs.readFileSync(path.join(path.dirname(exec_path), "package.json")));

      if (data.type === "module") {
        return true;
      } else {
        return false;
      }
    } catch (e) {// do nothing
    }

    try {
      data = JSON.parse(fs.readFileSync(path.join(path.dirname(exec_path), "..", "package.json")));

      if (data.type === "module") {
        return true;
      } else {
        return false;
      }
    } catch (e) {
      return false;
    }
  }
};
exports["default"] = _default;