"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _API = _interopRequireDefault(require("../../API"));

var _psList = _interopRequireDefault(require("../psList"));

var SERVICES_ASSOCIATION = {
  "mongodb,mongo": {
    module: "pm2-mongodb"
  },
  "redis,redis-server": {
    module: "pm2-redis"
  },
  "elasticsearch": {
    module: "pm2-elasticsearch"
  },
  "docker": {
    module: "pm2-monit-docker"
  },
  "consul": {
    module: "pm2-monit-consul"
  },
  "pm2": {
    module: "pm2-probe"
  },
  "fpm": {
    module: "pm2-php-fpm"
  }
}; // 'python,python3': {
//   module: 'pm2-python'
// },
// 'nginx': {
//   module: 'pm2-monit-nginx'
// },
// 'haproxy': {
//   module: 'pm2-monit-haproxy'
// },
// 'traeffik': {
//   module: 'pm2-monit-traeffik'
// }

var ServicesDetection = /*#__PURE__*/function () {
  function ServicesDetection() {
    (0, _classCallCheck2["default"])(this, ServicesDetection);
    (0, _defineProperty2["default"])(this, "pm2", void 0);
    this.pm2 = new _API["default"]();
  }

  (0, _createClass2["default"])(ServicesDetection, [{
    key: "startDetection",
    value: function startDetection(cb) {
      var _this = this;

      // Check running probes
      this.monitoredServices(function (err, pm2_services) {
        // Check running services
        _this.discover(function (err, required_modules) {
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          var required_monitoring_probes = Object.keys(required_modules); // Make the diff between
          // console.log(`Need to start following modules:`)
          // console.log(_.difference(required_monitoring_probes, pm2_services))

          _this.pm2.install("pm2-server-monit", function (err, apps) {
            cb();
          });
        });
      });
    }
  }, {
    key: "monitoredServices",
    value: function monitoredServices(cb) {
      var _this2 = this;

      var f_proc_list = [];
      this.pm2.list(function (err, proc_list) {
        f_proc_list = proc_list.map(function (p) {
          return p.name;
        });

        _this2.pm2.close();

        cb(err, f_proc_list);
      });
    }
  }, {
    key: "discover",
    value: function discover(cb) {
      (0, _psList["default"])().then(function (processes) {
        var supported_systems = Object.keys(SERVICES_ASSOCIATION);
        var required_modules = {};
        processes.forEach(function (proc) {
          supported_systems.forEach(function (sup_sys) {
            var proc_names = sup_sys.split(",");
            proc_names.forEach(function (proc_name) {
              if (proc.name.includes(proc_name) === true || proc.cmd.includes(proc_name) === true) {
                var key = SERVICES_ASSOCIATION[sup_sys].module;
                required_modules[key] = SERVICES_ASSOCIATION[sup_sys];
                required_modules[key].monit = proc;
              }
            });
          });
        });
        return cb(null, required_modules);
      })["catch"](function (e) {
        console.error("Error while listing processes", e);
      });
    }
  }]);
  return ServicesDetection;
}();

if (require.main === module) {
  var serviceDetection = new ServicesDetection();

  var process = function process(done) {
    serviceDetection.startDetection(function () {
      done();
    });
  };

  var iterate = function iterate() {
    process(function () {
      setTimeout(iterate, 3000);
    });
  };

  iterate();
}