"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _os = _interopRequireDefault(require("os"));

var _fs = _interopRequireDefault(require("fs"));

var _debug = _interopRequireDefault(require("debug"));

var _async = _interopRequireDefault(require("async"));

var _systeminformation = _interopRequireDefault(require("systeminformation"));

var _child_process = require("child_process");

var _psList = _interopRequireDefault(require("./psList"));

var _MeanCalc = _interopRequireDefault(require("./MeanCalc"));

var debug = (0, _debug["default"])("pm2:sysinfos");
var DEFAULT_CONVERSION = 1024 * 1024;

var SystemInfo = /*#__PURE__*/function () {
  function SystemInfo() {
    (0, _classCallCheck2["default"])(this, SystemInfo);
    (0, _defineProperty2["default"])(this, "infos", void 0);
    (0, _defineProperty2["default"])(this, "ping_timeout", void 0);
    (0, _defineProperty2["default"])(this, "restart", void 0);
    (0, _defineProperty2["default"])(this, "process", void 0);
    this.infos = {
      baseboard: {
        model: null,
        version: null
      },
      cpu: {
        manufacturer: null,
        brand: null,
        speedmax: null,
        cores: null,
        physicalCores: null,
        processors: null,
        temperature: null,
        usage: null
      },
      mem: {
        total: null,
        free: null,
        active: null
      },
      os: {
        platform: null,
        distro: null,
        release: null,
        codename: null,
        kernel: null,
        arch: null
      },
      fd: {
        opened: null,
        max: null
      },
      storage: {
        io: {
          read: new _MeanCalc["default"](15),
          write: new _MeanCalc["default"](15)
        },
        physical_disks: [{
          device: null,
          type: null,
          name: null,
          interfaceType: null,
          vendor: null
        }],
        filesystems: [{}]
      },
      connections: ["source_ip:source_port-dest_ip:dest_port-proc_name"],
      network: {
        latency: new _MeanCalc["default"](5),
        tx_5: new _MeanCalc["default"](5),
        rx_5: new _MeanCalc["default"](5),
        rx_errors_60: new _MeanCalc["default"](60),
        tx_errors_60: new _MeanCalc["default"](60),
        tx_dropped_60: new _MeanCalc["default"](60),
        rx_dropped_60: new _MeanCalc["default"](60)
      },
      // Procs
      containers: [],
      processes: {
        cpu_sorted: null,
        mem_sorted: null
      },
      services: {
        running: null,
        stopped: null
      }
    };
    this.restart = true;
    this.ping_timeout = null;
  } // Cast MeanCalc and other object to real value
  // This method retrieve the machine snapshot well formated


  (0, _createClass2["default"])(SystemInfo, [{
    key: "report",
    value: function report() {
      var report = JSON.parse(JSON.stringify(this.infos));
      report.network.latency = this.infos.network.latency.val();
      report.network.tx_5 = this.infos.network.tx_5.val();
      report.network.rx_5 = this.infos.network.rx_5.val();
      report.network.rx_errors_60 = this.infos.network.rx_errors_60.val();
      report.network.tx_errors_60 = this.infos.network.tx_errors_60.val();
      report.network.rx_dropped_60 = this.infos.network.rx_dropped_60.val();
      report.network.tx_dropped_60 = this.infos.network.tx_dropped_60.val();
      report.storage.io.read = this.infos.storage.io.read.val();
      report.storage.io.write = this.infos.storage.io.write.val();
      return report;
    }
  }, {
    key: "fork",
    value: function fork() {
      var _this = this;

      this.process = (0, _child_process.fork)(__filename, {
        detached: false,
        windowsHide: true,
        stdio: ["inherit", "inherit", "inherit", "ipc"]
      });
      this.process.on("exit", function (code) {
        console.log("systeminfos collection process offline with code ".concat(code)); // if (this.restart == true)
        //   this.fork()
      });
      this.process.on("error", function (e) {
        console.log("Sysinfo errored", e);
      });
      this.process.on("message", function (msg) {
        try {
          msg = JSON.parse(msg);
        } catch (e) {// do nothing
        }

        if (msg.cmd == "ping") {
          if (_this.process.connected == true) {
            try {
              _this.process.send("pong");
            } catch (e) {
              console.error("Cannot send message to Sysinfos");
            }
          }
        }
      });
    }
  }, {
    key: "query",
    value: function query(cb) {
      if (this.process.connected == true) {
        try {
          this.process.send("query");
        } catch (e) {
          return cb(new Error("not ready yet"), null);
        }
      } else {
        return cb(new Error("not ready yet"), null);
      }

      var res = function res(msg) {
        try {
          msg = JSON.parse(msg);
        } catch (e) {// do nothing
        }

        if (msg.cmd == "query:res") {
          listener.removeListener("message", res);
          return cb(null, msg.data);
        }
      };

      var listener = this.process.on("message", res);
    }
  }, {
    key: "kill",
    value: function kill() {
      this.restart = false;
      this.process.kill();
    }
  }, {
    key: "startCollection",
    value: function startCollection() {
      var _this2 = this;

      this.staticInformations();

      var _dockerCollection, _processCollection, _memCollection; // let servicesCollection;


      (_dockerCollection = function dockerCollection() {
        _this2.dockerSummary(function () {
          setTimeout(_dockerCollection.bind(_this2), 300);
        });
      })();

      (_processCollection = function processCollection() {
        _this2.processesSummary(function () {
          setTimeout(_processCollection.bind(_this2), 5000);
        });
      })(); // (servicesCollection = () => {
      //   this.servicesSummary(() => {
      //     setTimeout(servicesCollection.bind(this), 60000)
      //   })
      // })();


      (_memCollection = function memCollection() {
        _this2.memStats(function () {
          setTimeout(_memCollection.bind(_this2), 1000);
        });
      })();

      this.networkConnectionsWorker();
      this.disksStatsWorker();
      this.networkStatsWorker();
      this.cpuStatsWorker();
      this.fdStatsWorker();
      setInterval(function () {
        if (process.connected == false) {
          console.error("Sysinfos not connected, exiting");
          process.exit();
        }

        try {
          process.send(JSON.stringify({
            cmd: "ping"
          }));
        } catch (e) {
          console.error("PM2 is dead while doing process.send");
          process.exit();
        }

        _this2.ping_timeout = setTimeout(function () {
          console.error("PM2 is dead while waiting for a pong");
          process.exit();
        }, 2000);
      }, 3000); // Systeminfo receive command

      process.on("message", function (cmd) {
        if (cmd == "query") {
          try {
            var res = JSON.stringify({
              cmd: "query:res",
              data: _this2.report()
            });
            process.send(res);
          } catch (e) {
            console.error("Could not retrieve system informations", e);
          }
        } else if (cmd == "pong") {
          clearTimeout(_this2.ping_timeout);
        }
      });
    }
  }, {
    key: "staticInformations",
    value: function staticInformations() {
      var _this3 = this;

      var getCPU = function getCPU() {
        return _systeminformation["default"].cpu().then(function (data) {
          _this3.infos.cpu = {
            brand: data.manufacturer,
            model: data.brand,
            speed: data.speedmax,
            cores: data.cores,
            physicalCores: data.physicalCores
          };
        });
      };

      var getBaseboard = function getBaseboard() {
        return _systeminformation["default"].system().then(function (data) {
          _this3.infos.baseboard = {
            manufacturer: data.manufacturer,
            model: data.model,
            version: data.version
          };
        });
      };

      var getOsInfo = function getOsInfo() {
        return _systeminformation["default"].osInfo().then(function (data) {
          _this3.infos.os = {
            platform: data.platform,
            distro: data.distro,
            release: data.release,
            codename: data.codename,
            kernel: data.kernel,
            arch: data.arch
          };
        });
      };

      var diskLayout = function diskLayout() {
        _this3.infos.storage.physical_disks = [];
        return _systeminformation["default"].diskLayout().then(function (disks) {
          disks.forEach(function (disk) {
            _this3.infos.storage.physical_disks.push({
              device: disk.device,
              type: disk.type,
              name: disk.name,
              interfaceType: disk.interfaceType,
              vendor: disk.vendor
            });
          });
        });
      };

      getBaseboard().then(getCPU).then(getOsInfo).then(diskLayout)["catch"](function (e) {
        debug("Error when trying to retrieve static informations", e);
      });
    }
  }, {
    key: "dockerSummary",
    value: function dockerSummary(cb) {
      var _this4 = this;

      _systeminformation["default"].dockerContainers(true).then(function (containers) {
        var non_exited_containers = containers.filter(function (container) {
          return container.state != "exited";
        });
        var new_containers = [];

        _async["default"].forEach(non_exited_containers, function (container, next) {
          _systeminformation["default"].dockerContainerStats(container.id).then(function (stats) {
            var meta = container;
            stats[0].cpu_percent = stats[0].cpu_percent.toFixed(1);
            stats[0].mem_percent = stats[0].mem_percent.toFixed(1);
            stats[0].netIO.tx = (stats[0].netIO.tx / DEFAULT_CONVERSION).toFixed(1);
            stats[0].netIO.rx = (stats[0].netIO.rx / DEFAULT_CONVERSION).toFixed(1);
            stats[0].blockIO.w = (stats[0].blockIO.w / DEFAULT_CONVERSION).toFixed(1);
            stats[0].blockIO.r = (stats[0].blockIO.r / DEFAULT_CONVERSION).toFixed(1);
            meta.stats = Array.isArray(stats) == true ? stats[0] : null;
            new_containers.push(meta);
            next();
          })["catch"](function (e) {
            debug(e);
            next();
          });
        }, function (err) {
          if (err) {
            debug(err);
          }

          _this4.infos.containers = new_containers.sort(function (a, b) {
            var textA = a.name.toUpperCase();
            var textB = b.name.toUpperCase();
            return textA < textB ? -1 : textA > textB ? 1 : 0;
          });
          return cb();
        });
      })["catch"](function (e) {
        debug(e);
        return cb();
      });
    }
  }, {
    key: "servicesSummary",
    value: function servicesSummary() {
      var _this5 = this;

      _systeminformation["default"].services("*").then(function (services) {
        _this5.infos.services.running = services.filter(function (service) {
          return service.running === true;
        });
        _this5.infos.services.stopped = services.filter(function (service) {
          return service.running === false;
        });
      })["catch"](function (e) {
        debug(e);
      });
    }
  }, {
    key: "processesSummary",
    value: function processesSummary(cb) {
      var _this6 = this;

      (0, _psList["default"])().then(function (processes) {
        _this6.infos.processes.cpu_sorted = processes.filter(function (a) {
          return !(a.cmd.includes("SystemInfo") && a.cmd.includes("PM2"));
        }).sort(function (a, b) {
          return b.cpu - a.cpu;
        }).slice(0, 5);
        _this6.infos.processes.mem_sorted = processes.filter(function (a) {
          return !(a.cmd.includes("SystemInfo") && a.cmd.includes("PM2"));
        }).sort(function (a, b) {
          return b.memory - a.memory;
        }).slice(0, 5);
        return cb();
      })["catch"](function (e) {
        debug("Error when retrieving process list", e);
        return cb();
      });
    }
  }, {
    key: "cpuStatsWorker",
    value: function cpuStatsWorker() {
      var _this7 = this;

      var _cpuTempCollection;

      (_cpuTempCollection = function cpuTempCollection() {
        _systeminformation["default"].cpuTemperature().then(function (data) {
          _this7.infos.cpu.temperature = data.main;
          setTimeout(_cpuTempCollection.bind(_this7), 2000);
        })["catch"](function (e) {
          setTimeout(_cpuTempCollection.bind(_this7), 2000);
        });
      })();

      function fetch() {
        var _this8 = this;

        var startMeasure = computeUsage();
        setTimeout(function (_) {
          var endMeasure = computeUsage();
          var idleDifference = endMeasure.idle - startMeasure.idle;
          var totalDifference = endMeasure.total - startMeasure.total;
          var percentageCPU = (10000 - Math.round(10000 * idleDifference / totalDifference)) / 100;
          _this8.infos.cpu.usage = percentageCPU.toFixed(1);
        }, 100);
      }

      function computeUsage() {
        var totalIdle = 0;
        var totalTick = 0;

        var cpus = _os["default"].cpus();

        for (var i = 0, len = cpus.length; i < len; i++) {
          var cpu = cpus[i];

          for (var type in cpu.times) {
            totalTick += cpu.times[type];
          }

          totalIdle += cpu.times.idle;
        }

        return {
          idle: parseInt(totalIdle / cpus.length + ""),
          total: parseInt(totalTick / cpus.length + "")
        };
      }

      setInterval(fetch.bind(this), 1000);
      fetch.bind(this)();
    }
  }, {
    key: "memStats",
    value: function memStats(cb) {
      var _this9 = this;

      _systeminformation["default"].mem().then(function (data) {
        _this9.infos.mem.total = (data.total / DEFAULT_CONVERSION).toFixed(2);
        _this9.infos.mem.free = (data.free / DEFAULT_CONVERSION).toFixed(2);
        _this9.infos.mem.active = (data.active / DEFAULT_CONVERSION).toFixed(2);
        _this9.infos.mem.available = (data.available / DEFAULT_CONVERSION).toFixed(2);
        return cb();
      })["catch"](function (e) {
        debug("Error while getting memory info", e);
        return cb();
      });
    }
  }, {
    key: "networkConnectionsWorker",
    value: function networkConnectionsWorker() {
      var _this10 = this;

      var _retrieveConn;

      (_retrieveConn = function retrieveConn() {
        _systeminformation["default"].networkConnections().then(function (conns) {
          _this10.infos.connections = conns.filter(function (conn) {
            return conn.localport != "443" && conn.peerport != "443";
          }).map(function (conn) {
            return "".concat(conn.localaddress, ":").concat(conn.localport, "-").concat(conn.peeraddress, ":").concat(conn.peerport, "-").concat(conn.proc ? conn.proc : "unknown");
          });
          setTimeout(_retrieveConn.bind(_this10), 10 * 1000);
        })["catch"](function (e) {
          debug("Error while retrieving filesystem infos", e);
          setTimeout(_retrieveConn.bind(_this10), 10 * 1000);
        });
      })();
    }
  }, {
    key: "disksStatsWorker",
    value: function disksStatsWorker() {
      var _this11 = this;

      var rx = 0;
      var wx = 0;
      var started = false;

      var _fsSizeCollection, _ioCollection;

      (_fsSizeCollection = function fsSizeCollection() {
        _systeminformation["default"].fsSize().then(function (fss) {
          var fse = fss.filter(function (fs) {
            return fs.size / (1024 * 1024) > 200;
          });
          _this11.infos.storage.filesystems = fse;
          setTimeout(_fsSizeCollection.bind(_this11), 30 * 1000);
        })["catch"](function (e) {
          debug("Error while retrieving filesystem infos", e);
          setTimeout(_fsSizeCollection.bind(_this11), 10 * 1000);
        });
      })();

      (_ioCollection = function ioCollection() {
        _systeminformation["default"].fsStats().then(function (fs_stats) {
          var new_rx = fs_stats.rx;
          var new_wx = fs_stats.wx;
          var read = ((new_rx - rx) / DEFAULT_CONVERSION).toFixed(3);
          var write = ((new_wx - wx) / DEFAULT_CONVERSION).toFixed(3);

          if (started == true) {
            _this11.infos.storage.io.read.add(parseFloat(read));

            _this11.infos.storage.io.write.add(parseFloat(write));
          }

          rx = new_rx;
          wx = new_wx;
          started = true;
          setTimeout(_ioCollection.bind(_this11), 1000);
        })["catch"](function (e) {
          debug("Error while getting network statistics", e);
          setTimeout(_ioCollection.bind(_this11), 1000);
        });
      })();
    }
  }, {
    key: "fdStatsWorker",
    value: function fdStatsWorker() {
      var _this12 = this;

      var getFDOpened = function getFDOpened() {
        _fs["default"].readFile("/proc/sys/fs/file-nr", function (err, out) {
          if (err) {
            return;
          }

          var output = out.toString().trim();
          var parsed = output.split("\t");

          if (parsed.length !== 3) {
            return;
          }

          _this12.infos.fd.opened = parseInt(parsed[0]);
          _this12.infos.fd.max = parseInt(parsed[2]);
        });
      };

      setInterval(function () {
        getFDOpened();
      }, 20 * 1000);
      getFDOpened();
    }
  }, {
    key: "networkStatsWorker",
    value: function networkStatsWorker() {
      var _this13 = this;

      // let latencyCollection;
      var _networkStatsCollection; // (latencyCollection = () => {
      //   sysinfo.inetLatency()
      //     .then(latency => {
      //       this.infos.network.latency.add(latency)
      //       setTimeout(latencyCollection.bind(this), 2000)
      //     })
      //     .catch(e => {
      //       debug(e)
      //       setTimeout(latencyCollection.bind(this), 2000)
      //     })
      // })()


      _systeminformation["default"].networkInterfaceDefault(function (net_interface) {
        var started = false;
        var rx = 0;
        var tx = 0;
        var rx_e = 0;
        var tx_e = 0;
        var rx_d = 0;
        var tx_d = 0;

        (_networkStatsCollection = function networkStatsCollection() {
          _systeminformation["default"].networkStats(net_interface).then(function (net) {
            var new_rx = (net[0].rx_bytes - rx) / DEFAULT_CONVERSION;
            var new_tx = (net[0].tx_bytes - tx) / DEFAULT_CONVERSION;
            rx = net[0].rx_bytes;
            tx = net[0].tx_bytes;
            var new_rx_e = (net[0].rx_errors - rx_e) / DEFAULT_CONVERSION;
            var new_tx_e = (net[0].tx_errors - tx_e) / DEFAULT_CONVERSION;
            rx_e = net[0].rx_errors;
            tx_e = net[0].tx_errors;
            var new_rx_d = (net[0].rx_dropped - rx_d) / DEFAULT_CONVERSION;
            var new_tx_d = (net[0].tx_dropped - tx_d) / DEFAULT_CONVERSION;
            rx_d = net[0].rx_dropped;
            tx_d = net[0].tx_dropped;

            if (started == true) {
              _this13.infos.network.rx_5.add(new_rx);

              _this13.infos.network.tx_5.add(new_tx);

              _this13.infos.network.rx_errors_60.add(new_rx_e);

              _this13.infos.network.tx_errors_60.add(new_tx_e);

              _this13.infos.network.rx_dropped_60.add(new_rx_d);

              _this13.infos.network.tx_dropped_60.add(new_tx_d);
            }

            started = true;
            setTimeout(_networkStatsCollection.bind(_this13), 1000);
          })["catch"](function (e) {
            debug("Error on retrieving network stats", e);
            setTimeout(_networkStatsCollection.bind(_this13), 900);
          });
        })();
      });
    }
  }]);
  return SystemInfo;
}();

if (require.main === module) {
  var sys = new SystemInfo();
  sys.startCollection();
}

var _default = SystemInfo;
exports["default"] = _default;