"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _util = _interopRequireDefault(require("util"));

var _path = _interopRequireDefault(require("path"));

var _child_process = _interopRequireDefault(require("child_process"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var TEN_MEGABYTES = 1000 * 1000 * 10;

var execFile = _util["default"].promisify(_child_process["default"].execFile);

var windows = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var bin, _yield$execFile, stdout;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // Source: https://github.com/MarkTiedemann/fastlist
            bin = _path["default"].join(__dirname, "fastlist.exe");
            _context.next = 3;
            return execFile(bin, {
              maxBuffer: TEN_MEGABYTES
            });

          case 3:
            _yield$execFile = _context.sent;
            stdout = _yield$execFile.stdout;
            return _context.abrupt("return", stdout.trim().split("\r\n").map(function (line) {
              return line.split("\t");
            }).map(function (_ref2) {
              var _ref3 = (0, _slicedToArray2["default"])(_ref2, 3),
                  name = _ref3[0],
                  pid = _ref3[1],
                  ppid = _ref3[2];

              return {
                name: name,
                pid: Number.parseInt(pid, 10),
                ppid: Number.parseInt(ppid, 10)
              };
            }));

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function windows() {
    return _ref.apply(this, arguments);
  };
}();

var main = /*#__PURE__*/function () {
  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    var options,
        flags,
        ret,
        _args3 = arguments;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            options = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
            flags = (options.all === false ? "" : "a") + "wwxo";
            ret = {};
            _context3.next = 5;
            return Promise.all(["comm", "args", "ppid", "uid", "%cpu", "%mem"].map( /*#__PURE__*/function () {
              var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(cmd) {
                var _yield$execFile2, stdout, _iterator, _step, line, _line$split, _line$split2, pid, val;

                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return execFile("ps", [flags, "pid,".concat(cmd)], {
                          maxBuffer: TEN_MEGABYTES
                        });

                      case 2:
                        _yield$execFile2 = _context2.sent;
                        stdout = _yield$execFile2.stdout;
                        _iterator = _createForOfIteratorHelper(stdout.trim().split("\n").slice(1));

                        try {
                          for (_iterator.s(); !(_step = _iterator.n()).done;) {
                            line = _step.value;
                            line = line.trim();
                            _line$split = line.split(" ", 1), _line$split2 = (0, _slicedToArray2["default"])(_line$split, 1), pid = _line$split2[0];
                            val = line.slice(pid.length + 1).trim();

                            if (ret[pid] === undefined) {
                              ret[pid] = {};
                            }

                            ret[pid][cmd] = val;
                          }
                        } catch (err) {
                          _iterator.e(err);
                        } finally {
                          _iterator.f();
                        }

                      case 6:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x) {
                return _ref5.apply(this, arguments);
              };
            }()));

          case 5:
            return _context3.abrupt("return", Object.entries(ret).filter(function (_ref6) {
              var _ref7 = (0, _slicedToArray2["default"])(_ref6, 2),
                  value = _ref7[1];

              return value.comm && value.args && value.ppid && value.uid && value["%cpu"] && value["%mem"];
            }).map(function (_ref8) {
              var _ref9 = (0, _slicedToArray2["default"])(_ref8, 2),
                  key = _ref9[0],
                  value = _ref9[1];

              return {
                pid: Number.parseInt(key, 10),
                name: _path["default"].basename(value.comm),
                cmd: value.args,
                ppid: Number.parseInt(value.ppid, 10),
                uid: Number.parseInt(value.uid, 10),
                cpu: Number.parseFloat(value["%cpu"]),
                memory: Number.parseFloat(value["%mem"])
              };
            }));

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function main() {
    return _ref4.apply(this, arguments);
  };
}();

var _default = process.platform === "win32" ? windows : main;

exports["default"] = _default;