"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _pm2VersionCheck = _interopRequireDefault(require("@pm2/pm2-version-check"));

var _semver = _interopRequireDefault(require("semver"));

var _fs = _interopRequireDefault(require("fs"));

var _os = _interopRequireDefault(require("os"));

function hasDockerEnv() {
  try {
    _fs["default"].statSync("/.dockerenv");

    return true;
  } catch (_) {
    return false;
  }
}

function hasDockerCGroup() {
  try {
    return _fs["default"].readFileSync("/proc/self/cgroup", "utf8").includes("docker");
  } catch (_) {
    return false;
  }
}

function _default(opts) {
  var params = {
    state: opts.state,
    version: opts.version
  };

  try {
    params.os = _os["default"].type();
    params.uptime = Math.floor(process.uptime());
    params.nodev = process.versions.node;
    params.docker = hasDockerEnv() || hasDockerCGroup();
  } catch (e) {// do nothing
  }

  _pm2VersionCheck["default"].runCheck(params, function (err, pkg) {
    if (err) {
      return false;
    }

    if (!pkg.current_version) {
      return false;
    }

    if (opts.version && _semver["default"].lt(opts.version, pkg.current_version)) {
      console.log("[PM2] This PM2 is not UP TO DATE");
      console.log("[PM2] Upgrade to version %s", pkg.current_version);
    }
  });
}