"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.title = exports.subfield = exports.separator = exports.sep = exports.msg = exports.line = exports.li = exports.field = exports.dump = void 0;

var _util = _interopRequireDefault(require("util"));

// --------------------------------------------------------------------------------------------------------------------
//
// fmt.js - Command line output formatting.
//
// Copyright (c) 2012 Andrew Chilton - http://chilts.org/
// Written by Andrew Chilton <andychilton@gmail.com>
//
// License: http://opensource.org/licenses/MIT
//
// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
var sepC = "===============================================================================";
var lineC = "-------------------------------------------------------------------------------";
var fieldC = "                    "; // --------------------------------------------------------------------------------------------------------------------
// separator

var separator = function separator() {
  console.log(sepC);
}; // alias the above


exports.separator = separator;
var sep = separator; // line

exports.sep = sep;

var line = function line() {
  console.log(lineC);
}; // title


exports.line = line;

var title = function title(_title) {
  var out = "--- " + _title + " ";
  out += lineC.substr(out.length);
  console.log(out);
}; // field


exports.title = title;

var field = function field(key, value) {
  console.log("" + key + fieldC.substr(key.length) + " : " + value);
}; // subfield


exports.field = field;

var subfield = function subfield(key, value) {
  console.log("- " + key + fieldC.substr(key.length + 2) + " : " + value);
}; // list item


exports.subfield = subfield;

var li = function li(msg) {
  console.log("* " + msg);
}; // dump


exports.li = li;

var dump = function dump(data, name) {
  if (name) {
    console.log(name + " :", _util["default"].inspect(data, false, null, true));
  } else {
    console.log(_util["default"].inspect(data, false, null, true));
  }
}; // msg


exports.dump = dump;

var msg = function msg(_msg) {
  console.log(_msg);
}; // --------------------------------------------------------------------------------------------------------------------


exports.msg = msg;